/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 22:
/***/ ((module) => {

// Generated by Peggy 2.0.1.
//
// https://peggyjs.org/



function peg$subclass(child, parent) {
  function C() { this.constructor = child; }
  C.prototype = parent.prototype;
  child.prototype = new C();
}

function peg$SyntaxError(message, expected, found, location) {
  var self = Error.call(this, message);
  // istanbul ignore next Check is a necessary evil to support older environments
  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(self, peg$SyntaxError.prototype);
  }
  self.expected = expected;
  self.found = found;
  self.location = location;
  self.name = "SyntaxError";
  return self;
}

peg$subclass(peg$SyntaxError, Error);

function peg$padEnd(str, targetLength, padString) {
  padString = padString || " ";
  if (str.length > targetLength) { return str; }
  targetLength -= str.length;
  padString += padString.repeat(targetLength);
  return str + padString.slice(0, targetLength);
}

peg$SyntaxError.prototype.format = function(sources) {
  var str = "Error: " + this.message;
  if (this.location) {
    var src = null;
    var k;
    for (k = 0; k < sources.length; k++) {
      if (sources[k].source === this.location.source) {
        src = sources[k].text.split(/\r\n|\n|\r/g);
        break;
      }
    }
    var s = this.location.start;
    var loc = this.location.source + ":" + s.line + ":" + s.column;
    if (src) {
      var e = this.location.end;
      var filler = peg$padEnd("", s.line.toString().length, ' ');
      var line = src[s.line - 1];
      var last = s.line === e.line ? e.column : line.length + 1;
      var hatLen = (last - s.column) || 1;
      str += "\n --> " + loc + "\n"
          + filler + " |\n"
          + s.line + " | " + line + "\n"
          + filler + " | " + peg$padEnd("", s.column - 1, ' ')
          + peg$padEnd("", hatLen, "^");
    } else {
      str += "\n at " + loc;
    }
  }
  return str;
};

peg$SyntaxError.buildMessage = function(expected, found) {
  var DESCRIBE_EXPECTATION_FNS = {
    literal: function(expectation) {
      return "\"" + literalEscape(expectation.text) + "\"";
    },

    class: function(expectation) {
      var escapedParts = expectation.parts.map(function(part) {
        return Array.isArray(part)
          ? classEscape(part[0]) + "-" + classEscape(part[1])
          : classEscape(part);
      });

      return "[" + (expectation.inverted ? "^" : "") + escapedParts.join("") + "]";
    },

    any: function() {
      return "any character";
    },

    end: function() {
      return "end of input";
    },

    other: function(expectation) {
      return expectation.description;
    }
  };

  function hex(ch) {
    return ch.charCodeAt(0).toString(16).toUpperCase();
  }

  function literalEscape(s) {
    return s
      .replace(/\\/g, "\\\\")
      .replace(/"/g,  "\\\"")
      .replace(/\0/g, "\\0")
      .replace(/\t/g, "\\t")
      .replace(/\n/g, "\\n")
      .replace(/\r/g, "\\r")
      .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
      .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
  }

  function classEscape(s) {
    return s
      .replace(/\\/g, "\\\\")
      .replace(/\]/g, "\\]")
      .replace(/\^/g, "\\^")
      .replace(/-/g,  "\\-")
      .replace(/\0/g, "\\0")
      .replace(/\t/g, "\\t")
      .replace(/\n/g, "\\n")
      .replace(/\r/g, "\\r")
      .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
      .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
  }

  function describeExpectation(expectation) {
    return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
  }

  function describeExpected(expected) {
    var descriptions = expected.map(describeExpectation);
    var i, j;

    descriptions.sort();

    if (descriptions.length > 0) {
      for (i = 1, j = 1; i < descriptions.length; i++) {
        if (descriptions[i - 1] !== descriptions[i]) {
          descriptions[j] = descriptions[i];
          j++;
        }
      }
      descriptions.length = j;
    }

    switch (descriptions.length) {
      case 1:
        return descriptions[0];

      case 2:
        return descriptions[0] + " or " + descriptions[1];

      default:
        return descriptions.slice(0, -1).join(", ")
          + ", or "
          + descriptions[descriptions.length - 1];
    }
  }

  function describeFound(found) {
    return found ? "\"" + literalEscape(found) + "\"" : "end of input";
  }

  return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
};

function peg$parse(input, options) {
  options = options !== undefined ? options : {};

  var peg$FAILED = {};
  var peg$source = options.grammarSource;

  var peg$startRuleFunctions = { RootTemplate: peg$parseRootTemplate };
  var peg$startRuleFunction = peg$parseRootTemplate;

  var peg$c0 = "calc";
  var peg$c1 = "-";
  var peg$c2 = "-calc";
  var peg$c3 = "expression";
  var peg$c4 = "(";
  var peg$c5 = ")";
  var peg$c6 = "min(";
  var peg$c7 = ",";
  var peg$c8 = "max(";
  var peg$c9 = "clamp(";
  var peg$c10 = "+";
  var peg$c11 = "*";
  var peg$c12 = "/";
  var peg$c13 = "integer";
  var peg$c14 = "number";
  var peg$c15 = "%";
  var peg$c16 = "cm";
  var peg$c17 = "mm";
  var peg$c18 = "Q";
  var peg$c19 = "in";
  var peg$c20 = "pc";
  var peg$c21 = "pt";
  var peg$c22 = "px";
  var peg$c23 = "em";
  var peg$c24 = "rem";
  var peg$c25 = "ex";
  var peg$c26 = "rex";
  var peg$c27 = "cap";
  var peg$c28 = "rcap";
  var peg$c29 = "ch";
  var peg$c30 = "rch";
  var peg$c31 = "ic";
  var peg$c32 = "ric";
  var peg$c33 = "lh";
  var peg$c34 = "rlh";
  var peg$c35 = "vw";
  var peg$c36 = "vh";
  var peg$c37 = "vi";
  var peg$c38 = "vb";
  var peg$c39 = "vmin";
  var peg$c40 = "vmax";
  var peg$c41 = "dvw";
  var peg$c42 = "dvh";
  var peg$c43 = "dvi";
  var peg$c44 = "dvb";
  var peg$c45 = "dvmin";
  var peg$c46 = "dvmax";
  var peg$c47 = "lvw";
  var peg$c48 = "lvh";
  var peg$c49 = "lvi";
  var peg$c50 = "lvb";
  var peg$c51 = "lvmin";
  var peg$c52 = "lvmax";
  var peg$c53 = "svw";
  var peg$c54 = "svh";
  var peg$c55 = "svi";
  var peg$c56 = "svb";
  var peg$c57 = "svmin";
  var peg$c58 = "svmax";
  var peg$c59 = "deg";
  var peg$c60 = "grad";
  var peg$c61 = "rad";
  var peg$c62 = "turn";
  var peg$c63 = "s";
  var peg$c64 = "ms";
  var peg$c65 = "hz";
  var peg$c66 = "khz";
  var peg$c67 = "dpi";
  var peg$c68 = "dpcm";
  var peg$c69 = "dppx";
  var peg$c70 = "x";
  var peg$c71 = ".";
  var peg$c72 = "e";
  var peg$c73 = "var(";
  var peg$c74 = "env(";
  var peg$c75 = "constant(";

  var peg$r0 = /^[a-z]/;
  var peg$r1 = /^[+\-]/;
  var peg$r2 = /^[0-9]/;
  var peg$r3 = /^[^()+*\/\-]/;
  var peg$r4 = /^[ \t\n\r]/;
  var peg$r5 = /^[^)]/;

  var peg$e0 = peg$literalExpectation("calc", false);
  var peg$e1 = peg$literalExpectation("-", false);
  var peg$e2 = peg$classExpectation([["a", "z"]], false, false);
  var peg$e3 = peg$literalExpectation("-calc", false);
  var peg$e4 = peg$literalExpectation("expression", false);
  var peg$e5 = peg$literalExpectation("(", false);
  var peg$e6 = peg$literalExpectation(")", false);
  var peg$e7 = peg$literalExpectation("min(", false);
  var peg$e8 = peg$literalExpectation(",", false);
  var peg$e9 = peg$literalExpectation("max(", false);
  var peg$e10 = peg$literalExpectation("clamp(", false);
  var peg$e11 = peg$literalExpectation("+", false);
  var peg$e12 = peg$literalExpectation("*", false);
  var peg$e13 = peg$literalExpectation("/", false);
  var peg$e14 = peg$literalExpectation("integer", false);
  var peg$e15 = peg$literalExpectation("number", false);
  var peg$e16 = peg$literalExpectation("%", false);
  var peg$e17 = peg$literalExpectation("cm", false);
  var peg$e18 = peg$literalExpectation("mm", false);
  var peg$e19 = peg$literalExpectation("Q", false);
  var peg$e20 = peg$literalExpectation("in", false);
  var peg$e21 = peg$literalExpectation("pc", false);
  var peg$e22 = peg$literalExpectation("pt", false);
  var peg$e23 = peg$literalExpectation("px", false);
  var peg$e24 = peg$literalExpectation("em", false);
  var peg$e25 = peg$literalExpectation("rem", false);
  var peg$e26 = peg$literalExpectation("ex", false);
  var peg$e27 = peg$literalExpectation("rex", false);
  var peg$e28 = peg$literalExpectation("cap", false);
  var peg$e29 = peg$literalExpectation("rcap", false);
  var peg$e30 = peg$literalExpectation("ch", false);
  var peg$e31 = peg$literalExpectation("rch", false);
  var peg$e32 = peg$literalExpectation("ic", false);
  var peg$e33 = peg$literalExpectation("ric", false);
  var peg$e34 = peg$literalExpectation("lh", false);
  var peg$e35 = peg$literalExpectation("rlh", false);
  var peg$e36 = peg$literalExpectation("vw", false);
  var peg$e37 = peg$literalExpectation("vh", false);
  var peg$e38 = peg$literalExpectation("vi", false);
  var peg$e39 = peg$literalExpectation("vb", false);
  var peg$e40 = peg$literalExpectation("vmin", false);
  var peg$e41 = peg$literalExpectation("vmax", false);
  var peg$e42 = peg$literalExpectation("dvw", false);
  var peg$e43 = peg$literalExpectation("dvh", false);
  var peg$e44 = peg$literalExpectation("dvi", false);
  var peg$e45 = peg$literalExpectation("dvb", false);
  var peg$e46 = peg$literalExpectation("dvmin", false);
  var peg$e47 = peg$literalExpectation("dvmax", false);
  var peg$e48 = peg$literalExpectation("lvw", false);
  var peg$e49 = peg$literalExpectation("lvh", false);
  var peg$e50 = peg$literalExpectation("lvi", false);
  var peg$e51 = peg$literalExpectation("lvb", false);
  var peg$e52 = peg$literalExpectation("lvmin", false);
  var peg$e53 = peg$literalExpectation("lvmax", false);
  var peg$e54 = peg$literalExpectation("svw", false);
  var peg$e55 = peg$literalExpectation("svh", false);
  var peg$e56 = peg$literalExpectation("svi", false);
  var peg$e57 = peg$literalExpectation("svb", false);
  var peg$e58 = peg$literalExpectation("svmin", false);
  var peg$e59 = peg$literalExpectation("svmax", false);
  var peg$e60 = peg$literalExpectation("deg", false);
  var peg$e61 = peg$literalExpectation("grad", false);
  var peg$e62 = peg$literalExpectation("rad", false);
  var peg$e63 = peg$literalExpectation("turn", false);
  var peg$e64 = peg$literalExpectation("s", false);
  var peg$e65 = peg$literalExpectation("ms", false);
  var peg$e66 = peg$literalExpectation("hz", false);
  var peg$e67 = peg$literalExpectation("khz", false);
  var peg$e68 = peg$literalExpectation("dpi", false);
  var peg$e69 = peg$literalExpectation("dpcm", false);
  var peg$e70 = peg$literalExpectation("dppx", false);
  var peg$e71 = peg$literalExpectation("x", false);
  var peg$e72 = peg$otherExpectation("number");
  var peg$e73 = peg$classExpectation(["+", "-"], false, false);
  var peg$e74 = peg$classExpectation([["0", "9"]], false, false);
  var peg$e75 = peg$literalExpectation(".", false);
  var peg$e76 = peg$literalExpectation("e", false);
  var peg$e77 = peg$literalExpectation("var(", false);
  var peg$e78 = peg$literalExpectation("env(", false);
  var peg$e79 = peg$literalExpectation("constant(", false);
  var peg$e80 = peg$classExpectation(["(", ")", "+", "*", "/", "-"], true, false);
  var peg$e81 = peg$classExpectation([], false, false);
  var peg$e82 = peg$classExpectation([" ", "\t", "\n", "\r"], false, false);
  var peg$e83 = peg$classExpectation([")"], true, false);
  var peg$e84 = peg$otherExpectation("whitespace");

  var peg$f0 = function(content) {
    const result = {type: "var", value: text(), values: content.values, kind: "root"}
    // console.log(result)
    return result
    };
  var peg$f1 = function() { return text() };
  var peg$f2 = function() { return text() };
  var peg$f3 = function() { return text() };
  var peg$f4 = function(prefix, value) { return { type: "calc", prefix: prefix, value: value } };
  var peg$f5 = function(prefix, expr) { return { type: "calc", prefix: prefix, value: expr } };
  var peg$f6 = function(expr, more) {
      const values = [expr, ...more.map(element => element[3])]
      return {type: "min", values}
    };
  var peg$f7 = function(expr, more) {
      const values = [expr, ...more.map(element => element[3])]
      return {type: "max", values}
    };
  var peg$f8 = function(min, value, max) {
      return {type: "clamp", min, value, max}
    };
  var peg$f9 = function(head, tail) {
      const terms = [{operation: "+", value: head}, ...tail.map(element => ({operation: element[1], value: element[3]}))]
      
      return {type: "addition", values: terms}
    };
  var peg$f10 = function(head, tail) {
      const terms = [{operation: "*", value: head}, ...tail.map(element => ({operation: element[1], value: element[3]}))]
     return {type: "multiplication", values: terms}
    };
  var peg$f11 = function(expr) { return {type: "parenthesis", value: expr} };
  var peg$f12 = function() { error("Unknown unit") ; return true };
  var peg$f13 = function(number, unit) {
    return {type: "value", value: parseFloat(number, 10), unit: unit || "number" }; };
  var peg$f14 = function() { return text() };
  var peg$f15 = function() { return text() };
  var peg$f16 = function() { return text() };
  var peg$f17 = function(content) {
    const result = {type: "var", value: text(), values: content.values, kind: "customProperty"}
    // console.log(result)
    return result
    };
  var peg$f18 = function(value) { return {value: value, text: text()}};
  var peg$f19 = function(value) { return {value: value, text: text()}};
  var peg$f20 = function(tc) {return {values: tc.values, value: text()}};
  var peg$f21 = function() {return {values: {}, value: text()}};
  var peg$f22 = function(value, tc) {return {values: {...tc.values, [value.text]: value.value}, value: text()}};
  var peg$f23 = function(value, tc) {return {values: {...tc.values, [value.text]: value.value}, value: text()}};
  var peg$f24 = function(tc) {return {values: tc.values, value: text()}};
  var peg$f25 = function() {return {values: {}, value: text()}};
  var peg$currPos = 0;
  var peg$savedPos = 0;
  var peg$posDetailsCache = [{ line: 1, column: 1 }];
  var peg$maxFailPos = 0;
  var peg$maxFailExpected = [];
  var peg$silentFails = 0;

  var peg$result;

  if ("startRule" in options) {
    if (!(options.startRule in peg$startRuleFunctions)) {
      throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
    }

    peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
  }

  function text() {
    return input.substring(peg$savedPos, peg$currPos);
  }

  function offset() {
    return peg$savedPos;
  }

  function range() {
    return {
      source: peg$source,
      start: peg$savedPos,
      end: peg$currPos
    };
  }

  function location() {
    return peg$computeLocation(peg$savedPos, peg$currPos);
  }

  function expected(description, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw peg$buildStructuredError(
      [peg$otherExpectation(description)],
      input.substring(peg$savedPos, peg$currPos),
      location
    );
  }

  function error(message, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw peg$buildSimpleError(message, location);
  }

  function peg$literalExpectation(text, ignoreCase) {
    return { type: "literal", text: text, ignoreCase: ignoreCase };
  }

  function peg$classExpectation(parts, inverted, ignoreCase) {
    return { type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase };
  }

  function peg$anyExpectation() {
    return { type: "any" };
  }

  function peg$endExpectation() {
    return { type: "end" };
  }

  function peg$otherExpectation(description) {
    return { type: "other", description: description };
  }

  function peg$computePosDetails(pos) {
    var details = peg$posDetailsCache[pos];
    var p;

    if (details) {
      return details;
    } else {
      p = pos - 1;
      while (!peg$posDetailsCache[p]) {
        p--;
      }

      details = peg$posDetailsCache[p];
      details = {
        line: details.line,
        column: details.column
      };

      while (p < pos) {
        if (input.charCodeAt(p) === 10) {
          details.line++;
          details.column = 1;
        } else {
          details.column++;
        }

        p++;
      }

      peg$posDetailsCache[pos] = details;

      return details;
    }
  }

  function peg$computeLocation(startPos, endPos) {
    var startPosDetails = peg$computePosDetails(startPos);
    var endPosDetails = peg$computePosDetails(endPos);

    return {
      source: peg$source,
      start: {
        offset: startPos,
        line: startPosDetails.line,
        column: startPosDetails.column
      },
      end: {
        offset: endPos,
        line: endPosDetails.line,
        column: endPosDetails.column
      }
    };
  }

  function peg$fail(expected) {
    if (peg$currPos < peg$maxFailPos) { return; }

    if (peg$currPos > peg$maxFailPos) {
      peg$maxFailPos = peg$currPos;
      peg$maxFailExpected = [];
    }

    peg$maxFailExpected.push(expected);
  }

  function peg$buildSimpleError(message, location) {
    return new peg$SyntaxError(message, null, null, location);
  }

  function peg$buildStructuredError(expected, found, location) {
    return new peg$SyntaxError(
      peg$SyntaxError.buildMessage(expected, found),
      expected,
      found,
      location
    );
  }

  function peg$parseRootTemplate() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseRootTemplateContent();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f0(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseValue() {
    var s0;

    s0 = peg$parseCalc();
    if (s0 === peg$FAILED) {
      s0 = peg$parseMin();
      if (s0 === peg$FAILED) {
        s0 = peg$parseMax();
        if (s0 === peg$FAILED) {
          s0 = peg$parseClamp();
          if (s0 === peg$FAILED) {
            s0 = peg$parseNumber();
            if (s0 === peg$FAILED) {
              s0 = peg$parseCustomProperty();
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parseCalcPrefix() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    if (input.substr(peg$currPos, 4) === peg$c0) {
      s1 = peg$c0;
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e0); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f1();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 45) {
        s1 = peg$c1;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e1); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        if (peg$r0.test(input.charAt(peg$currPos))) {
          s3 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e2); }
        }
        if (s3 !== peg$FAILED) {
          while (s3 !== peg$FAILED) {
            s2.push(s3);
            if (peg$r0.test(input.charAt(peg$currPos))) {
              s3 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e2); }
            }
          }
        } else {
          s2 = peg$FAILED;
        }
        if (s2 !== peg$FAILED) {
          if (input.substr(peg$currPos, 5) === peg$c2) {
            s3 = peg$c2;
            peg$currPos += 5;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e3); }
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f2();
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 10) === peg$c3) {
          s1 = peg$c3;
          peg$currPos += 10;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e4); }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f3();
        }
        s0 = s1;
      }
    }

    return s0;
  }

  function peg$parseCalc() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parseCalcPrefix();
    if (s1 !== peg$FAILED) {
      if (input.charCodeAt(peg$currPos) === 40) {
        s2 = peg$c4;
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e5); }
      }
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parseValue();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          if (input.charCodeAt(peg$currPos) === 41) {
            s6 = peg$c5;
            peg$currPos++;
          } else {
            s6 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e6); }
          }
          if (s6 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f4(s1, s4);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseCalcPrefix();
      if (s1 !== peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 40) {
          s2 = peg$c4;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e5); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseExpression();
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 41) {
              s6 = peg$c5;
              peg$currPos++;
            } else {
              s6 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e6); }
            }
            if (s6 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f5(s1, s4);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parseMin() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    if (input.substr(peg$currPos, 4) === peg$c6) {
      s1 = peg$c6;
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e7); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseExpression();
      if (s3 !== peg$FAILED) {
        s4 = [];
        s5 = peg$currPos;
        s6 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 44) {
          s7 = peg$c7;
          peg$currPos++;
        } else {
          s7 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e8); }
        }
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = peg$parseExpression();
          if (s9 !== peg$FAILED) {
            s6 = [s6, s7, s8, s9];
            s5 = s6;
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        while (s5 !== peg$FAILED) {
          s4.push(s5);
          s5 = peg$currPos;
          s6 = peg$parse_();
          if (input.charCodeAt(peg$currPos) === 44) {
            s7 = peg$c7;
            peg$currPos++;
          } else {
            s7 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e8); }
          }
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseExpression();
            if (s9 !== peg$FAILED) {
              s6 = [s6, s7, s8, s9];
              s5 = s6;
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        s5 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 41) {
          s6 = peg$c5;
          peg$currPos++;
        } else {
          s6 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e6); }
        }
        if (s6 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f6(s3, s4);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseMax() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    if (input.substr(peg$currPos, 4) === peg$c8) {
      s1 = peg$c8;
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e9); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseExpression();
      if (s3 !== peg$FAILED) {
        s4 = [];
        s5 = peg$currPos;
        s6 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 44) {
          s7 = peg$c7;
          peg$currPos++;
        } else {
          s7 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e8); }
        }
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = peg$parseExpression();
          if (s9 !== peg$FAILED) {
            s6 = [s6, s7, s8, s9];
            s5 = s6;
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        while (s5 !== peg$FAILED) {
          s4.push(s5);
          s5 = peg$currPos;
          s6 = peg$parse_();
          if (input.charCodeAt(peg$currPos) === 44) {
            s7 = peg$c7;
            peg$currPos++;
          } else {
            s7 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e8); }
          }
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseExpression();
            if (s9 !== peg$FAILED) {
              s6 = [s6, s7, s8, s9];
              s5 = s6;
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        s5 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 41) {
          s6 = peg$c5;
          peg$currPos++;
        } else {
          s6 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e6); }
        }
        if (s6 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f7(s3, s4);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseClamp() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13;

    s0 = peg$currPos;
    if (input.substr(peg$currPos, 6) === peg$c9) {
      s1 = peg$c9;
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e10); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseExpression();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 44) {
          s5 = peg$c7;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e8); }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseExpression();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 44) {
              s9 = peg$c7;
              peg$currPos++;
            } else {
              s9 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e8); }
            }
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseExpression();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                if (input.charCodeAt(peg$currPos) === 41) {
                  s13 = peg$c5;
                  peg$currPos++;
                } else {
                  s13 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e6); }
                }
                if (s13 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f8(s3, s7, s11);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseExpression() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseTerm();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 43) {
        s5 = peg$c10;
        peg$currPos++;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e11); }
      }
      if (s5 === peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 45) {
          s5 = peg$c1;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e1); }
        }
      }
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseTerm();
        if (s7 !== peg$FAILED) {
          s4 = [s4, s5, s6, s7];
          s3 = s4;
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 43) {
          s5 = peg$c10;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e11); }
        }
        if (s5 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 45) {
            s5 = peg$c1;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e1); }
          }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseTerm();
          if (s7 !== peg$FAILED) {
            s4 = [s4, s5, s6, s7];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f9(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseTerm() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseFactor();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 42) {
        s5 = peg$c11;
        peg$currPos++;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e12); }
      }
      if (s5 === peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 47) {
          s5 = peg$c12;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e13); }
        }
      }
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseFactor();
        if (s7 !== peg$FAILED) {
          s4 = [s4, s5, s6, s7];
          s3 = s4;
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 42) {
          s5 = peg$c11;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e12); }
        }
        if (s5 === peg$FAILED) {
          if (input.charCodeAt(peg$currPos) === 47) {
            s5 = peg$c12;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e13); }
          }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseFactor();
          if (s7 !== peg$FAILED) {
            s4 = [s4, s5, s6, s7];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f10(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseFactor() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 40) {
      s1 = peg$c4;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e5); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseExpression();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 41) {
          s5 = peg$c5;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e6); }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f11(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseValue();
    }

    return s0;
  }

  function peg$parseUnitSuffix() {
    var s0, s1;

    if (input.substr(peg$currPos, 7) === peg$c13) {
      s0 = peg$c13;
      peg$currPos += 7;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e14); }
    }
    if (s0 === peg$FAILED) {
      if (input.substr(peg$currPos, 6) === peg$c14) {
        s0 = peg$c14;
        peg$currPos += 6;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e15); }
      }
      if (s0 === peg$FAILED) {
        if (input.charCodeAt(peg$currPos) === 37) {
          s0 = peg$c15;
          peg$currPos++;
        } else {
          s0 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e16); }
        }
        if (s0 === peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c16) {
            s0 = peg$c16;
            peg$currPos += 2;
          } else {
            s0 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e17); }
          }
          if (s0 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c17) {
              s0 = peg$c17;
              peg$currPos += 2;
            } else {
              s0 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e18); }
            }
            if (s0 === peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 81) {
                s0 = peg$c18;
                peg$currPos++;
              } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e19); }
              }
              if (s0 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c19) {
                  s0 = peg$c19;
                  peg$currPos += 2;
                } else {
                  s0 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e20); }
                }
                if (s0 === peg$FAILED) {
                  if (input.substr(peg$currPos, 2) === peg$c20) {
                    s0 = peg$c20;
                    peg$currPos += 2;
                  } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$e21); }
                  }
                  if (s0 === peg$FAILED) {
                    if (input.substr(peg$currPos, 2) === peg$c21) {
                      s0 = peg$c21;
                      peg$currPos += 2;
                    } else {
                      s0 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$e22); }
                    }
                    if (s0 === peg$FAILED) {
                      if (input.substr(peg$currPos, 2) === peg$c22) {
                        s0 = peg$c22;
                        peg$currPos += 2;
                      } else {
                        s0 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$e23); }
                      }
                      if (s0 === peg$FAILED) {
                        if (input.substr(peg$currPos, 2) === peg$c23) {
                          s0 = peg$c23;
                          peg$currPos += 2;
                        } else {
                          s0 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$e24); }
                        }
                        if (s0 === peg$FAILED) {
                          if (input.substr(peg$currPos, 3) === peg$c24) {
                            s0 = peg$c24;
                            peg$currPos += 3;
                          } else {
                            s0 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$e25); }
                          }
                          if (s0 === peg$FAILED) {
                            if (input.substr(peg$currPos, 2) === peg$c25) {
                              s0 = peg$c25;
                              peg$currPos += 2;
                            } else {
                              s0 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$e26); }
                            }
                            if (s0 === peg$FAILED) {
                              if (input.substr(peg$currPos, 3) === peg$c26) {
                                s0 = peg$c26;
                                peg$currPos += 3;
                              } else {
                                s0 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$e27); }
                              }
                              if (s0 === peg$FAILED) {
                                if (input.substr(peg$currPos, 3) === peg$c27) {
                                  s0 = peg$c27;
                                  peg$currPos += 3;
                                } else {
                                  s0 = peg$FAILED;
                                  if (peg$silentFails === 0) { peg$fail(peg$e28); }
                                }
                                if (s0 === peg$FAILED) {
                                  if (input.substr(peg$currPos, 4) === peg$c28) {
                                    s0 = peg$c28;
                                    peg$currPos += 4;
                                  } else {
                                    s0 = peg$FAILED;
                                    if (peg$silentFails === 0) { peg$fail(peg$e29); }
                                  }
                                  if (s0 === peg$FAILED) {
                                    if (input.substr(peg$currPos, 2) === peg$c29) {
                                      s0 = peg$c29;
                                      peg$currPos += 2;
                                    } else {
                                      s0 = peg$FAILED;
                                      if (peg$silentFails === 0) { peg$fail(peg$e30); }
                                    }
                                    if (s0 === peg$FAILED) {
                                      if (input.substr(peg$currPos, 3) === peg$c30) {
                                        s0 = peg$c30;
                                        peg$currPos += 3;
                                      } else {
                                        s0 = peg$FAILED;
                                        if (peg$silentFails === 0) { peg$fail(peg$e31); }
                                      }
                                      if (s0 === peg$FAILED) {
                                        if (input.substr(peg$currPos, 2) === peg$c31) {
                                          s0 = peg$c31;
                                          peg$currPos += 2;
                                        } else {
                                          s0 = peg$FAILED;
                                          if (peg$silentFails === 0) { peg$fail(peg$e32); }
                                        }
                                        if (s0 === peg$FAILED) {
                                          if (input.substr(peg$currPos, 3) === peg$c32) {
                                            s0 = peg$c32;
                                            peg$currPos += 3;
                                          } else {
                                            s0 = peg$FAILED;
                                            if (peg$silentFails === 0) { peg$fail(peg$e33); }
                                          }
                                          if (s0 === peg$FAILED) {
                                            if (input.substr(peg$currPos, 2) === peg$c33) {
                                              s0 = peg$c33;
                                              peg$currPos += 2;
                                            } else {
                                              s0 = peg$FAILED;
                                              if (peg$silentFails === 0) { peg$fail(peg$e34); }
                                            }
                                            if (s0 === peg$FAILED) {
                                              if (input.substr(peg$currPos, 3) === peg$c34) {
                                                s0 = peg$c34;
                                                peg$currPos += 3;
                                              } else {
                                                s0 = peg$FAILED;
                                                if (peg$silentFails === 0) { peg$fail(peg$e35); }
                                              }
                                              if (s0 === peg$FAILED) {
                                                if (input.substr(peg$currPos, 2) === peg$c35) {
                                                  s0 = peg$c35;
                                                  peg$currPos += 2;
                                                } else {
                                                  s0 = peg$FAILED;
                                                  if (peg$silentFails === 0) { peg$fail(peg$e36); }
                                                }
                                                if (s0 === peg$FAILED) {
                                                  if (input.substr(peg$currPos, 2) === peg$c36) {
                                                    s0 = peg$c36;
                                                    peg$currPos += 2;
                                                  } else {
                                                    s0 = peg$FAILED;
                                                    if (peg$silentFails === 0) { peg$fail(peg$e37); }
                                                  }
                                                  if (s0 === peg$FAILED) {
                                                    if (input.substr(peg$currPos, 2) === peg$c37) {
                                                      s0 = peg$c37;
                                                      peg$currPos += 2;
                                                    } else {
                                                      s0 = peg$FAILED;
                                                      if (peg$silentFails === 0) { peg$fail(peg$e38); }
                                                    }
                                                    if (s0 === peg$FAILED) {
                                                      if (input.substr(peg$currPos, 2) === peg$c38) {
                                                        s0 = peg$c38;
                                                        peg$currPos += 2;
                                                      } else {
                                                        s0 = peg$FAILED;
                                                        if (peg$silentFails === 0) { peg$fail(peg$e39); }
                                                      }
                                                      if (s0 === peg$FAILED) {
                                                        if (input.substr(peg$currPos, 4) === peg$c39) {
                                                          s0 = peg$c39;
                                                          peg$currPos += 4;
                                                        } else {
                                                          s0 = peg$FAILED;
                                                          if (peg$silentFails === 0) { peg$fail(peg$e40); }
                                                        }
                                                        if (s0 === peg$FAILED) {
                                                          if (input.substr(peg$currPos, 4) === peg$c40) {
                                                            s0 = peg$c40;
                                                            peg$currPos += 4;
                                                          } else {
                                                            s0 = peg$FAILED;
                                                            if (peg$silentFails === 0) { peg$fail(peg$e41); }
                                                          }
                                                          if (s0 === peg$FAILED) {
                                                            if (input.substr(peg$currPos, 3) === peg$c41) {
                                                              s0 = peg$c41;
                                                              peg$currPos += 3;
                                                            } else {
                                                              s0 = peg$FAILED;
                                                              if (peg$silentFails === 0) { peg$fail(peg$e42); }
                                                            }
                                                            if (s0 === peg$FAILED) {
                                                              if (input.substr(peg$currPos, 3) === peg$c42) {
                                                                s0 = peg$c42;
                                                                peg$currPos += 3;
                                                              } else {
                                                                s0 = peg$FAILED;
                                                                if (peg$silentFails === 0) { peg$fail(peg$e43); }
                                                              }
                                                              if (s0 === peg$FAILED) {
                                                                if (input.substr(peg$currPos, 3) === peg$c43) {
                                                                  s0 = peg$c43;
                                                                  peg$currPos += 3;
                                                                } else {
                                                                  s0 = peg$FAILED;
                                                                  if (peg$silentFails === 0) { peg$fail(peg$e44); }
                                                                }
                                                                if (s0 === peg$FAILED) {
                                                                  if (input.substr(peg$currPos, 3) === peg$c44) {
                                                                    s0 = peg$c44;
                                                                    peg$currPos += 3;
                                                                  } else {
                                                                    s0 = peg$FAILED;
                                                                    if (peg$silentFails === 0) { peg$fail(peg$e45); }
                                                                  }
                                                                  if (s0 === peg$FAILED) {
                                                                    if (input.substr(peg$currPos, 5) === peg$c45) {
                                                                      s0 = peg$c45;
                                                                      peg$currPos += 5;
                                                                    } else {
                                                                      s0 = peg$FAILED;
                                                                      if (peg$silentFails === 0) { peg$fail(peg$e46); }
                                                                    }
                                                                    if (s0 === peg$FAILED) {
                                                                      if (input.substr(peg$currPos, 5) === peg$c46) {
                                                                        s0 = peg$c46;
                                                                        peg$currPos += 5;
                                                                      } else {
                                                                        s0 = peg$FAILED;
                                                                        if (peg$silentFails === 0) { peg$fail(peg$e47); }
                                                                      }
                                                                      if (s0 === peg$FAILED) {
                                                                        if (input.substr(peg$currPos, 3) === peg$c47) {
                                                                          s0 = peg$c47;
                                                                          peg$currPos += 3;
                                                                        } else {
                                                                          s0 = peg$FAILED;
                                                                          if (peg$silentFails === 0) { peg$fail(peg$e48); }
                                                                        }
                                                                        if (s0 === peg$FAILED) {
                                                                          if (input.substr(peg$currPos, 3) === peg$c48) {
                                                                            s0 = peg$c48;
                                                                            peg$currPos += 3;
                                                                          } else {
                                                                            s0 = peg$FAILED;
                                                                            if (peg$silentFails === 0) { peg$fail(peg$e49); }
                                                                          }
                                                                          if (s0 === peg$FAILED) {
                                                                            if (input.substr(peg$currPos, 3) === peg$c49) {
                                                                              s0 = peg$c49;
                                                                              peg$currPos += 3;
                                                                            } else {
                                                                              s0 = peg$FAILED;
                                                                              if (peg$silentFails === 0) { peg$fail(peg$e50); }
                                                                            }
                                                                            if (s0 === peg$FAILED) {
                                                                              if (input.substr(peg$currPos, 3) === peg$c50) {
                                                                                s0 = peg$c50;
                                                                                peg$currPos += 3;
                                                                              } else {
                                                                                s0 = peg$FAILED;
                                                                                if (peg$silentFails === 0) { peg$fail(peg$e51); }
                                                                              }
                                                                              if (s0 === peg$FAILED) {
                                                                                if (input.substr(peg$currPos, 5) === peg$c51) {
                                                                                  s0 = peg$c51;
                                                                                  peg$currPos += 5;
                                                                                } else {
                                                                                  s0 = peg$FAILED;
                                                                                  if (peg$silentFails === 0) { peg$fail(peg$e52); }
                                                                                }
                                                                                if (s0 === peg$FAILED) {
                                                                                  if (input.substr(peg$currPos, 5) === peg$c52) {
                                                                                    s0 = peg$c52;
                                                                                    peg$currPos += 5;
                                                                                  } else {
                                                                                    s0 = peg$FAILED;
                                                                                    if (peg$silentFails === 0) { peg$fail(peg$e53); }
                                                                                  }
                                                                                  if (s0 === peg$FAILED) {
                                                                                    if (input.substr(peg$currPos, 3) === peg$c53) {
                                                                                      s0 = peg$c53;
                                                                                      peg$currPos += 3;
                                                                                    } else {
                                                                                      s0 = peg$FAILED;
                                                                                      if (peg$silentFails === 0) { peg$fail(peg$e54); }
                                                                                    }
                                                                                    if (s0 === peg$FAILED) {
                                                                                      if (input.substr(peg$currPos, 3) === peg$c54) {
                                                                                        s0 = peg$c54;
                                                                                        peg$currPos += 3;
                                                                                      } else {
                                                                                        s0 = peg$FAILED;
                                                                                        if (peg$silentFails === 0) { peg$fail(peg$e55); }
                                                                                      }
                                                                                      if (s0 === peg$FAILED) {
                                                                                        if (input.substr(peg$currPos, 3) === peg$c55) {
                                                                                          s0 = peg$c55;
                                                                                          peg$currPos += 3;
                                                                                        } else {
                                                                                          s0 = peg$FAILED;
                                                                                          if (peg$silentFails === 0) { peg$fail(peg$e56); }
                                                                                        }
                                                                                        if (s0 === peg$FAILED) {
                                                                                          if (input.substr(peg$currPos, 3) === peg$c56) {
                                                                                            s0 = peg$c56;
                                                                                            peg$currPos += 3;
                                                                                          } else {
                                                                                            s0 = peg$FAILED;
                                                                                            if (peg$silentFails === 0) { peg$fail(peg$e57); }
                                                                                          }
                                                                                          if (s0 === peg$FAILED) {
                                                                                            if (input.substr(peg$currPos, 5) === peg$c57) {
                                                                                              s0 = peg$c57;
                                                                                              peg$currPos += 5;
                                                                                            } else {
                                                                                              s0 = peg$FAILED;
                                                                                              if (peg$silentFails === 0) { peg$fail(peg$e58); }
                                                                                            }
                                                                                            if (s0 === peg$FAILED) {
                                                                                              if (input.substr(peg$currPos, 5) === peg$c58) {
                                                                                                s0 = peg$c58;
                                                                                                peg$currPos += 5;
                                                                                              } else {
                                                                                                s0 = peg$FAILED;
                                                                                                if (peg$silentFails === 0) { peg$fail(peg$e59); }
                                                                                              }
                                                                                              if (s0 === peg$FAILED) {
                                                                                                if (input.substr(peg$currPos, 3) === peg$c59) {
                                                                                                  s0 = peg$c59;
                                                                                                  peg$currPos += 3;
                                                                                                } else {
                                                                                                  s0 = peg$FAILED;
                                                                                                  if (peg$silentFails === 0) { peg$fail(peg$e60); }
                                                                                                }
                                                                                                if (s0 === peg$FAILED) {
                                                                                                  if (input.substr(peg$currPos, 4) === peg$c60) {
                                                                                                    s0 = peg$c60;
                                                                                                    peg$currPos += 4;
                                                                                                  } else {
                                                                                                    s0 = peg$FAILED;
                                                                                                    if (peg$silentFails === 0) { peg$fail(peg$e61); }
                                                                                                  }
                                                                                                  if (s0 === peg$FAILED) {
                                                                                                    if (input.substr(peg$currPos, 3) === peg$c61) {
                                                                                                      s0 = peg$c61;
                                                                                                      peg$currPos += 3;
                                                                                                    } else {
                                                                                                      s0 = peg$FAILED;
                                                                                                      if (peg$silentFails === 0) { peg$fail(peg$e62); }
                                                                                                    }
                                                                                                    if (s0 === peg$FAILED) {
                                                                                                      if (input.substr(peg$currPos, 4) === peg$c62) {
                                                                                                        s0 = peg$c62;
                                                                                                        peg$currPos += 4;
                                                                                                      } else {
                                                                                                        s0 = peg$FAILED;
                                                                                                        if (peg$silentFails === 0) { peg$fail(peg$e63); }
                                                                                                      }
                                                                                                      if (s0 === peg$FAILED) {
                                                                                                        if (input.charCodeAt(peg$currPos) === 115) {
                                                                                                          s0 = peg$c63;
                                                                                                          peg$currPos++;
                                                                                                        } else {
                                                                                                          s0 = peg$FAILED;
                                                                                                          if (peg$silentFails === 0) { peg$fail(peg$e64); }
                                                                                                        }
                                                                                                        if (s0 === peg$FAILED) {
                                                                                                          if (input.substr(peg$currPos, 2) === peg$c64) {
                                                                                                            s0 = peg$c64;
                                                                                                            peg$currPos += 2;
                                                                                                          } else {
                                                                                                            s0 = peg$FAILED;
                                                                                                            if (peg$silentFails === 0) { peg$fail(peg$e65); }
                                                                                                          }
                                                                                                          if (s0 === peg$FAILED) {
                                                                                                            if (input.substr(peg$currPos, 2) === peg$c65) {
                                                                                                              s0 = peg$c65;
                                                                                                              peg$currPos += 2;
                                                                                                            } else {
                                                                                                              s0 = peg$FAILED;
                                                                                                              if (peg$silentFails === 0) { peg$fail(peg$e66); }
                                                                                                            }
                                                                                                            if (s0 === peg$FAILED) {
                                                                                                              if (input.substr(peg$currPos, 3) === peg$c66) {
                                                                                                                s0 = peg$c66;
                                                                                                                peg$currPos += 3;
                                                                                                              } else {
                                                                                                                s0 = peg$FAILED;
                                                                                                                if (peg$silentFails === 0) { peg$fail(peg$e67); }
                                                                                                              }
                                                                                                              if (s0 === peg$FAILED) {
                                                                                                                if (input.substr(peg$currPos, 3) === peg$c67) {
                                                                                                                  s0 = peg$c67;
                                                                                                                  peg$currPos += 3;
                                                                                                                } else {
                                                                                                                  s0 = peg$FAILED;
                                                                                                                  if (peg$silentFails === 0) { peg$fail(peg$e68); }
                                                                                                                }
                                                                                                                if (s0 === peg$FAILED) {
                                                                                                                  if (input.substr(peg$currPos, 4) === peg$c68) {
                                                                                                                    s0 = peg$c68;
                                                                                                                    peg$currPos += 4;
                                                                                                                  } else {
                                                                                                                    s0 = peg$FAILED;
                                                                                                                    if (peg$silentFails === 0) { peg$fail(peg$e69); }
                                                                                                                  }
                                                                                                                  if (s0 === peg$FAILED) {
                                                                                                                    if (input.substr(peg$currPos, 4) === peg$c69) {
                                                                                                                      s0 = peg$c69;
                                                                                                                      peg$currPos += 4;
                                                                                                                    } else {
                                                                                                                      s0 = peg$FAILED;
                                                                                                                      if (peg$silentFails === 0) { peg$fail(peg$e70); }
                                                                                                                    }
                                                                                                                    if (s0 === peg$FAILED) {
                                                                                                                      if (input.charCodeAt(peg$currPos) === 120) {
                                                                                                                        s0 = peg$c70;
                                                                                                                        peg$currPos++;
                                                                                                                      } else {
                                                                                                                        s0 = peg$FAILED;
                                                                                                                        if (peg$silentFails === 0) { peg$fail(peg$e71); }
                                                                                                                      }
                                                                                                                      if (s0 === peg$FAILED) {
                                                                                                                        s0 = peg$currPos;
                                                                                                                        peg$silentFails++;
                                                                                                                        if (peg$r0.test(input.charAt(peg$currPos))) {
                                                                                                                          s1 = input.charAt(peg$currPos);
                                                                                                                          peg$currPos++;
                                                                                                                        } else {
                                                                                                                          s1 = peg$FAILED;
                                                                                                                          if (peg$silentFails === 0) { peg$fail(peg$e2); }
                                                                                                                        }
                                                                                                                        peg$silentFails--;
                                                                                                                        if (s1 === peg$FAILED) {
                                                                                                                          s0 = undefined;
                                                                                                                        } else {
                                                                                                                          peg$currPos = s0;
                                                                                                                          s0 = peg$FAILED;
                                                                                                                        }
                                                                                                                        if (s0 === peg$FAILED) {
                                                                                                                          peg$savedPos = peg$currPos;
                                                                                                                          s0 = peg$f12();
                                                                                                                          if (s0) {
                                                                                                                            s0 = peg$FAILED;
                                                                                                                          } else {
                                                                                                                            s0 = undefined;
                                                                                                                          }
                                                                                                                        }
                                                                                                                      }
                                                                                                                    }
                                                                                                                  }
                                                                                                                }
                                                                                                              }
                                                                                                            }
                                                                                                          }
                                                                                                        }
                                                                                                      }
                                                                                                    }
                                                                                                  }
                                                                                                }
                                                                                              }
                                                                                            }
                                                                                          }
                                                                                        }
                                                                                      }
                                                                                    }
                                                                                  }
                                                                                }
                                                                              }
                                                                            }
                                                                          }
                                                                        }
                                                                      }
                                                                    }
                                                                  }
                                                                }
                                                              }
                                                            }
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parseNumber() {
    var s0, s1, s2, s3, s4, s5, s6;

    peg$silentFails++;
    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$currPos;
    s3 = peg$parse_();
    if (peg$r1.test(input.charAt(peg$currPos))) {
      s4 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s4 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e73); }
    }
    if (s4 === peg$FAILED) {
      s4 = null;
    }
    s5 = peg$parseBaseNumber();
    if (s5 !== peg$FAILED) {
      s6 = peg$parseExponent();
      if (s6 === peg$FAILED) {
        s6 = null;
      }
      s3 = [s3, s4, s5, s6];
      s2 = s3;
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      s1 = input.substring(s1, peg$currPos);
    } else {
      s1 = s2;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      s3 = peg$parseUnitSuffix();
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s2 = input.substring(s2, peg$currPos);
      peg$savedPos = s0;
      s0 = peg$f13(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e72); }
    }

    return s0;
  }

  function peg$parseBaseNumber() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    if (peg$r2.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e74); }
    }
    while (s2 !== peg$FAILED) {
      s1.push(s2);
      if (peg$r2.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e74); }
      }
    }
    if (input.charCodeAt(peg$currPos) === 46) {
      s2 = peg$c71;
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e75); }
    }
    if (s2 !== peg$FAILED) {
      s3 = [];
      if (peg$r2.test(input.charAt(peg$currPos))) {
        s4 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e74); }
      }
      if (s4 !== peg$FAILED) {
        while (s4 !== peg$FAILED) {
          s3.push(s4);
          if (peg$r2.test(input.charAt(peg$currPos))) {
            s4 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e74); }
          }
        }
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f14();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = [];
      if (peg$r2.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e74); }
      }
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          if (peg$r2.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e74); }
          }
        }
      } else {
        s1 = peg$FAILED;
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f15();
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parseExponent() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 101) {
      s1 = peg$c72;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e76); }
    }
    if (s1 !== peg$FAILED) {
      if (peg$r1.test(input.charAt(peg$currPos))) {
        s2 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e73); }
      }
      if (s2 === peg$FAILED) {
        s2 = null;
      }
      s3 = peg$parseBaseNumber();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f16();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseCustomPropertyPrefix() {
    var s0;

    if (input.substr(peg$currPos, 4) === peg$c73) {
      s0 = peg$c73;
      peg$currPos += 4;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e77); }
    }
    if (s0 === peg$FAILED) {
      if (input.substr(peg$currPos, 4) === peg$c74) {
        s0 = peg$c74;
        peg$currPos += 4;
      } else {
        s0 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e78); }
      }
      if (s0 === peg$FAILED) {
        if (input.substr(peg$currPos, 9) === peg$c75) {
          s0 = peg$c75;
          peg$currPos += 9;
        } else {
          s0 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e79); }
        }
      }
    }

    return s0;
  }

  function peg$parseCustomProperty() {
    var s0, s1, s2;

    s0 = peg$currPos;
    s1 = peg$parseCustomPropertyPrefix();
    if (s1 !== peg$FAILED) {
      s2 = peg$parseTemplateContent();
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f17(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseSpecialValue() {
    var s0;

    s0 = peg$parseCalc();
    if (s0 === peg$FAILED) {
      s0 = peg$parseMin();
      if (s0 === peg$FAILED) {
        s0 = peg$parseMax();
        if (s0 === peg$FAILED) {
          s0 = peg$parseClamp();
          if (s0 === peg$FAILED) {
            s0 = peg$parseNumber();
          }
        }
      }
    }

    return s0;
  }

  function peg$parseTextValue() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseValue();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f18(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseRootTextValue() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseValue();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f19(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseRootTemplateContentSeparator() {
    var s0, s1, s2;

    s0 = peg$currPos;
    if (peg$r3.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e80); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseRootTemplateContent();
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f20(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = [];
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e81); }
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e81); }
      }
      peg$savedPos = s0;
      s1 = peg$f21();
      s0 = s1;
    }

    return s0;
  }

  function peg$parseRootTemplateContent() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$currPos;
    peg$silentFails++;
    if (peg$r4.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e82); }
    }
    peg$silentFails--;
    if (s2 === peg$FAILED) {
      s1 = undefined;
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseTextValue();
      if (s2 !== peg$FAILED) {
        s3 = peg$parseRootTemplateContentSeparator();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f22(s2, s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseRootTemplateContentSeparator();
    }

    return s0;
  }

  function peg$parseTemplateContent() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$currPos;
    peg$silentFails++;
    if (peg$r4.test(input.charAt(peg$currPos))) {
      s2 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e82); }
    }
    peg$silentFails--;
    if (s2 === peg$FAILED) {
      s1 = undefined;
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseTextValue();
      if (s2 !== peg$FAILED) {
        s3 = peg$parseTemplateContent();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f23(s2, s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (peg$r5.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e83); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parseTemplateContent();
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f24(s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 41) {
          s1 = peg$c5;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e6); }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f25();
        }
        s0 = s1;
      }
    }

    return s0;
  }

  function peg$parse_() {
    var s0, s1;

    peg$silentFails++;
    s0 = [];
    if (peg$r4.test(input.charAt(peg$currPos))) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e82); }
    }
    while (s1 !== peg$FAILED) {
      s0.push(s1);
      if (peg$r4.test(input.charAt(peg$currPos))) {
        s1 = input.charAt(peg$currPos);
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e82); }
      }
    }
    peg$silentFails--;
    s1 = peg$FAILED;
    if (peg$silentFails === 0) { peg$fail(peg$e84); }

    return s0;
  }

  peg$result = peg$startRuleFunction();

  if (peg$result !== peg$FAILED && peg$currPos === input.length) {
    return peg$result;
  } else {
    if (peg$result !== peg$FAILED && peg$currPos < input.length) {
      peg$fail(peg$endExpectation());
    }

    throw peg$buildStructuredError(
      peg$maxFailExpected,
      peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
      peg$maxFailPos < input.length
        ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
        : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
    );
  }
}

module.exports = {
  SyntaxError: peg$SyntaxError,
  parse: peg$parse
};


/***/ }),

/***/ 35:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.checkValidDivider = exports.checkMinMaxCompatibility = exports.checkMultiplicationCompatibility = exports.checkAdditionCompatibility = exports.compareValues = exports.getCompatibleUnits = exports.convertToCanonicalUnit = exports.isNumber = exports.unitTypes = exports.resolutionUnitFactors = exports.frequencyUnitFactors = exports.timeUnitFactors = exports.angleUnitFactors = exports.absoluteLengthUnitFactors = exports.cssUnits = exports.dimensionUnits = exports.resolutionUnits = exports.frequencyUnits = exports.timeUnits = exports.angleUnits = exports.percentageUnits = exports.numberUnits = exports.integerUnits = exports.lengthUnits = exports.relativeLengthUnits = exports.viewportPercentageLengthUnits = exports.fontRelativeLengthUnits = exports.absoluteLengthUnits = exports.includes = void 0;
function includes(coll, el) {
    return coll.includes(el);
}
exports.includes = includes;
exports.absoluteLengthUnits = [
    "cm",
    "mm",
    "Q",
    "in",
    "pc",
    "pt",
    "px",
];
exports.fontRelativeLengthUnits = [
    "em",
    "rem",
    "ex",
    "rex",
    "cap",
    "rcap",
    "ch",
    "rch",
    "ic",
    "ric",
    "lh",
    "rlh",
];
exports.viewportPercentageLengthUnits = [
    "vw",
    "vh",
    "vi",
    "vb",
    "vmin",
    "vmax",
    "dvw",
    "dvh",
    "dvi",
    "dvb",
    "dvmin",
    "dvmax",
    "lvw",
    "lvh",
    "lvi",
    "lvb",
    "lvmin",
    "lvmax",
    "svw",
    "svh",
    "svi",
    "svb",
    "svmin",
    "svmax",
];
exports.relativeLengthUnits = [
    ...exports.fontRelativeLengthUnits,
    ...exports.viewportPercentageLengthUnits,
];
exports.lengthUnits = [
    ...exports.absoluteLengthUnits,
    ...exports.relativeLengthUnits,
];
exports.integerUnits = ["integer"];
exports.numberUnits = ["number"];
exports.percentageUnits = ["%"];
exports.angleUnits = ["deg", "grad", "rad", "turn"];
exports.timeUnits = ["s", "ms"];
exports.frequencyUnits = ["hz", "khz"];
exports.resolutionUnits = ["dpi", "dpcm", "dppx", "x"];
exports.dimensionUnits = [
    ...exports.lengthUnits,
    ...exports.angleUnits,
    ...exports.timeUnits,
    ...exports.frequencyUnits,
    ...exports.resolutionUnits,
];
exports.cssUnits = [
    ...exports.integerUnits,
    ...exports.numberUnits,
    ...exports.percentageUnits,
    ...exports.dimensionUnits,
];
exports.absoluteLengthUnitFactors = {
    cm: 96 / 2.54,
    mm: 96 / 2.54 / 10,
    Q: 96 / 2.54 / 10 / 4,
    in: 96,
    pc: 16,
    pt: 96 / 72,
    px: 1,
};
exports.angleUnitFactors = {
    rad: 1,
    deg: Math.PI / 180,
    grad: Math.PI / 200,
    turn: Math.PI * 2,
};
exports.timeUnitFactors = {
    ms: 0.001,
    s: 1,
};
exports.frequencyUnitFactors = {
    khz: 0.001,
    hz: 1,
};
exports.resolutionUnitFactors = {
    dpi: 96,
    dpcm: 96 / 2.54,
    dppx: 1,
    x: 1,
};
exports.unitTypes = [
    "number",
    "integer",
    "percentage",
    "length",
    "angle",
    "time",
    "frequency",
    "resolution",
];
/** Lowercase the unit name, if it is a known unit name. This is needed, because some units can also contain uppercase letters (e.g. kHz) */
const getLowercaseUnitName = (element) => {
    const unitName = typeof element === "string" ? element : element.unit;
    return includes(exports.cssUnits, unitName.toLowerCase())
        ? unitName.toLowerCase()
        : unitName;
};
const isInteger = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 0.5 : element.value;
    return (includes(exports.integerUnits, unit) ||
        (includes(exports.numberUnits, unit) && Number.isInteger(value)));
};
const isNumber = (element) => {
    const unit = getLowercaseUnitName(element);
    return includes(exports.numberUnits, unit) || includes(exports.integerUnits, unit);
};
exports.isNumber = isNumber;
const isPercentage = (element) => {
    const unit = getLowercaseUnitName(element);
    return includes(exports.percentageUnits, unit);
};
const isAbsoluteLength = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return (includes(exports.absoluteLengthUnits, unit) || ((0, exports.isNumber)(element) && value === 0));
};
const isViewportPercentageLength = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return (includes(exports.viewportPercentageLengthUnits, unit) ||
        ((0, exports.isNumber)(element) && value === 0));
};
const isLength = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return (includes(exports.lengthUnits, unit) ||
        includes(exports.percentageUnits, unit) ||
        ((0, exports.isNumber)(element) && value === 0));
};
const isAngle = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return includes(exports.angleUnits, unit) || ((0, exports.isNumber)(element) && value === 0);
};
const isTime = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return includes(exports.timeUnits, unit) || ((0, exports.isNumber)(element) && value === 0);
};
const isFrequency = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return includes(exports.frequencyUnits, unit) || ((0, exports.isNumber)(element) && value === 0);
};
const isResolution = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = typeof element === "string" ? 1 : element.value;
    return includes(exports.resolutionUnits, unit);
};
/** Convert units to a canonical type. For example all absolute lengths will be converted to px */
const convertToCanonicalUnit = (element) => {
    const unit = getLowercaseUnitName(element);
    const value = element.value;
    if (includes(exports.absoluteLengthUnits, unit)) {
        return {
            value: value * exports.absoluteLengthUnitFactors[unit],
            unit: "px",
        };
    }
    if (includes(exports.angleUnits, unit)) {
        return {
            value: value * exports.angleUnitFactors[unit],
            unit: "rad",
        };
    }
    if (includes(exports.timeUnits, unit)) {
        return {
            value: value * exports.timeUnitFactors[unit],
            unit: "s",
        };
    }
    if (includes(exports.frequencyUnits, unit)) {
        return {
            value: value * exports.frequencyUnitFactors[unit],
            unit: "hz",
        };
    }
    if (includes(exports.resolutionUnits, unit)) {
        return {
            value: value * exports.resolutionUnitFactors[unit],
            unit: "dppx",
        };
    }
    if ((0, exports.isNumber)(unit)) {
        return {
            value: value,
            unit: "number",
        };
    }
    return {
        unit,
        value,
    };
};
exports.convertToCanonicalUnit = convertToCanonicalUnit;
const getCompatibleUnits = (unit) => [
    ...(isInteger(unit) ? ["integer"] : []),
    ...((0, exports.isNumber)(unit) ? ["number"] : []),
    ...(isPercentage(unit) ? ["percentage"] : []),
    ...(isLength(unit) ? ["length"] : []),
    ...(isAngle(unit) ? ["angle"] : []),
    ...(isTime(unit) ? ["time"] : []),
    ...(isFrequency(unit) ? ["frequency"] : []),
    ...(isResolution(unit) ? ["resolution"] : []),
];
exports.getCompatibleUnits = getCompatibleUnits;
const parseViewportPercentageLengthUnit = (unit) => {
    const parsedUnit = {
        prefix: unit.startsWith("v")
            ? ""
            : unit.charAt(0),
        suffix: unit.split("v")[1],
    };
    return parsedUnit;
};
/** Compare two values with unit.
 * A return value of 0 means that the values are the same.
 * A return value of 1 means that the first value is larger.
 * A return value of -1 means that the second value is larger.
 * A return value of undefined means that the values are not comparable, but compatible.
 * Throws an error if the values are not compatible
 */
const compareValues = (a, b) => {
    const canonicalA = (0, exports.convertToCanonicalUnit)(a);
    const canonicalB = (0, exports.convertToCanonicalUnit)(b);
    const compatibleA = (0, exports.getCompatibleUnits)(a);
    const compatibleB = (0, exports.getCompatibleUnits)(b);
    if (!compatibleA.find((unit) => compatibleB.includes(unit))) {
        throw new Error(`Cannot compare values with incompatible units (${a.unit} with ${b.unit})`);
    }
    const comparison = canonicalA.value > canonicalB.value
        ? 1
        : canonicalA.value < canonicalB.value
            ? -1
            : 0;
    // Check all direkt comparisons. Because we use canonical units, we can assume that the values are in the same unit, if both are the same absolute category
    if (
    // (isNumber(canonicalA) && isNumber(canonicalB)) ||
    // (isAngle(canonicalA) && isAngle(canonicalB)) ||
    // (isTime(canonicalA) && isTime(canonicalB)) ||
    // (isFrequency(canonicalA) && isFrequency(canonicalB)) ||
    // (isResolution(canonicalA) && isResolution(canonicalB)) ||
    // (isPercentage(canonicalA) && isPercentage(canonicalB)) ||
    // (isAbsoluteLength(canonicalA) && isAbsoluteLength(canonicalB)) ||
    canonicalA.unit === canonicalB.unit ||
        canonicalA.value === 0 ||
        canonicalB.value === 0) {
        return comparison;
    }
    if (includes(exports.viewportPercentageLengthUnits, canonicalA.unit) &&
        includes(exports.viewportPercentageLengthUnits, canonicalB.unit)) {
        const aType = parseViewportPercentageLengthUnit(canonicalA.unit);
        const bType = parseViewportPercentageLengthUnit(canonicalB.unit);
        if (comparison === 1 &&
            aType.suffix === bType.suffix &&
            (aType.prefix === "l" || bType.prefix === "s")) {
            return 1;
        }
        if (comparison === -1 &&
            aType.suffix === bType.suffix &&
            (bType.prefix === "l" || aType.prefix === "s")) {
            return -1;
        }
        if (comparison === 1 &&
            aType.prefix === bType.prefix &&
            (aType.suffix === "max" || bType.suffix === "min")) {
            return 1;
        }
        if (comparison === -1 &&
            aType.prefix === bType.prefix &&
            (bType.suffix === "max" || aType.suffix === "min")) {
            return -1;
        }
    }
    return undefined;
};
exports.compareValues = compareValues;
const checkAdditionCompatibility = (...elements) => {
    const compatibleUnits = elements.map((element) => Array.isArray(element) ? element : (0, exports.getCompatibleUnits)(element));
    if (compatibleUnits.length === 1) {
        return compatibleUnits[0];
    }
    const commonUnits = compatibleUnits.reduce((acc, curr) => {
        return acc.filter((unit) => curr.includes(unit));
    }, [...exports.unitTypes]);
    return commonUnits;
};
exports.checkAdditionCompatibility = checkAdditionCompatibility;
const checkMultiplicationCompatibility = (...elements) => {
    const compatibleUnits = elements.map((element) => Array.isArray(element) ? element : (0, exports.getCompatibleUnits)(element));
    if (compatibleUnits.length === 1) {
        return compatibleUnits[0];
    }
    const elementsWithUnit = compatibleUnits.flatMap((compatibleUnits) => compatibleUnits.includes("number") ? [] : [compatibleUnits], 0);
    const possibleResultUnits = elementsWithUnit.length > 1
        ? [] // Cannot multiply if there is more then one unit in the equation
        : elementsWithUnit.length === 1
            ? elementsWithUnit[0] // If there is only one unit, the result has to be that unit
            : [...compatibleUnits.flat()].filter((value, index, array) => array.indexOf(value) === index); // If there is no unit, the result can be any of the possible units
    return possibleResultUnits;
};
exports.checkMultiplicationCompatibility = checkMultiplicationCompatibility;
const checkMinMaxCompatibility = (...elements) => {
    const compatibleUnits = elements.map((element) => Array.isArray(element) ? element : (0, exports.getCompatibleUnits)(element));
    const commonUnits = compatibleUnits.reduce((acc, curr) => {
        return acc.filter((unit) => curr.includes(unit));
    }, [...exports.unitTypes]);
    return commonUnits;
};
exports.checkMinMaxCompatibility = checkMinMaxCompatibility;
const checkValidDivider = (element) => {
    const compatibleUnits = Array.isArray(element)
        ? element
        : (0, exports.getCompatibleUnits)(element);
    return (compatibleUnits.includes("number") &&
        (Array.isArray(element) || element.value !== 0));
};
exports.checkValidDivider = checkValidDivider;


/***/ }),

/***/ 144:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.minifyCSSCalc = void 0;
const parseCalc_1 = __nccwpck_require__(91);
// @ts-ignore-error: The parser is generated during the build step
const cssCalcParser_1 = __nccwpck_require__(22);
const minifyCSSCalc = (input) => {
    return (0, parseCalc_1.parseCalc)(input, cssCalcParser_1.parse);
};
exports.minifyCSSCalc = minifyCSSCalc;
exports["default"] = exports.minifyCSSCalc;


/***/ }),

/***/ 512:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.optimizeAst = void 0;
/** Applies each stage of optimizations until they dont mutate the ast */
const optimizeAst = (ast, stages, storage = {}) => {
    if (stages.length === 0) {
        return ast;
    }
    // const [currentStage, ...nextStages] = stages;
    // const previousString = JSON.stringify(ast);
    // const optimizedAst =
    // const optimizedString = JSON.stringify(optimizedAst);
    // debugNode(optimizedAst);
    return processStage(ast, stages, storage);
};
exports.optimizeAst = optimizeAst;
/** Apply a stage */
const processStage = (ast, stage, storage) => {
    if (Array.isArray(stage)) {
        const [currentStage, ...nextStages] = stage;
        const previousString = JSON.stringify(ast);
        const optimizedAst = stage.reduce((ast, stage) => processStage(ast, stage, storage), ast);
        const optimizedString = JSON.stringify(optimizedAst);
        return previousString === optimizedString
            ? optimizedAst
            : processStage(optimizedAst, stage, storage);
    }
    else {
        return stage(ast, storage);
    }
};


/***/ }),

/***/ 666:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.addCalcOnRootLevelIfRequired = void 0;
const visitor_1 = __nccwpck_require__(9);
const transformRootNode = (node, calcPrefix) => {
    const rootNode = node.type === "addition" || node.type === "multiplication"
        ? {
            type: "calc",
            prefix: calcPrefix,
            value: node,
        }
        : node.type === "parenthesis"
            ? Object.assign(Object.assign({}, node), { type: "calc", prefix: calcPrefix }) : node;
    return rootNode;
};
const addCalcOnRootLevelIfRequired = (node, storage) => {
    var _a, _b;
    const calcPrefix = (_b = (_a = storage.knownCalcPrefixes) === null || _a === void 0 ? void 0 : _a.find((prefix) => prefix !== "calc")) !== null && _b !== void 0 ? _b : "calc";
    return (0, visitor_1.visitor)(transformRootNode(node, calcPrefix), () => true, (node) => {
        if (node.type !== "var") {
            return node;
        }
        return Object.assign(Object.assign({}, node), { values: Object.fromEntries(Object.entries(node.values).map(([key, value]) => [
                key,
                transformRootNode(value, calcPrefix),
            ])) });
    });
};
exports.addCalcOnRootLevelIfRequired = addCalcOnRootLevelIfRequired;


/***/ }),

/***/ 762:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.addNecessaryParenthesis = void 0;
const visitor_1 = __nccwpck_require__(9);
/** Addition inside a multiplication needs to be enclosed by parenthesis */
const addNecessaryParenthesis = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "multiplication") {
            return node;
        }
        return Object.assign(Object.assign({}, node), { values: node.values.map((value) => (Object.assign(Object.assign({}, value), { value: value.value.type === "addition"
                    ? {
                        type: "parenthesis",
                        value: value.value,
                    }
                    : value.value }))) });
    });
};
exports.addNecessaryParenthesis = addNecessaryParenthesis;


/***/ }),

/***/ 154:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.addValueNodesInAddition = void 0;
const reverseVisitor_1 = __nccwpck_require__(101);
const addValueNodesInAddition = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        if (node.type !== "addition") {
            return node;
        }
        const valueElements = node.values.flatMap((value) => value.value.type === "value" ? [Object.assign(Object.assign({}, value), { value: value.value })] : []);
        const otherElements = node.values.filter((value) => value.value.type !== "value");
        const sumPerUnit = valueElements.reduce((acc, value) => {
            var _a;
            return (Object.assign(Object.assign({}, acc), { [value.value.unit]: ((_a = acc[value.value.unit]) !== null && _a !== void 0 ? _a : 0) +
                    (value.operation === "+" ? value.value.value : -value.value.value) }));
        }, {});
        const newElements = Object.entries(sumPerUnit).map(([unit, value]) => ({
            operation: "+",
            value: { type: "value", unit, value },
        }));
        return Object.assign(Object.assign({}, node), { values: [...newElements, ...otherElements] });
    });
};
exports.addValueNodesInAddition = addValueNodesInAddition;


/***/ }),

/***/ 14:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.removeUnneccessaryAddition = void 0;
const reverseVisitor_1 = __nccwpck_require__(101);
const removeUnneccessaryAddition = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        if (node.type !== "addition") {
            return node;
        }
        if (node.values.length === 1 && node.values[0].operation === "+") {
            return node.values[0].value;
        }
        if (node.values.length === 1 &&
            node.values[0].value.type === "value" &&
            node.values[0].operation === "-") {
            return Object.assign(Object.assign({}, node.values[0].value), { value: -node.values[0].value.value });
        }
        if (node.values.length === 0) {
            return Object.assign(Object.assign({}, node), { type: "value", unit: "number", value: 0 });
        }
        return node;
    });
};
exports.removeUnneccessaryAddition = removeUnneccessaryAddition;


/***/ }),

/***/ 735:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.combineDuplicateNodesInAddition = void 0;
const reverseVisitor_1 = __nccwpck_require__(101);
const stringifyNode_1 = __nccwpck_require__(955);
/** Move all factors in multiplications into a seperate value
 *
 * var(--a) + var(--a) + 2 => var(--a)*2 + 2
 * var(--a) + 2*var(--a) + 2 => var(--a)*3 + 2
 *
 */
const combineDuplicateNodesInAddition = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        if (node.type !== "addition") {
            return node;
        }
        const values = node.values.map((value) => {
            if (value.value.type === "value") {
                const normalizedValue = Object.assign(Object.assign({}, value.value), { value: 1 });
                return Object.assign(Object.assign({}, value), { factor: (value.operation === "+" ? 1 : -1) * value.value.value, text: (0, stringifyNode_1.stringifyNode)(normalizedValue), value: normalizedValue, operation: "+" });
            }
            if (value.value.type === "multiplication") {
                const factor = value.value.values.reduce((acc, element) => element.value.type === "value" && element.value.unit === "number"
                    ? element.operation === "*"
                        ? acc * element.value.value
                        : acc / element.value.value
                    : acc, 1);
                const nonFactorNodes = value.value.values.filter((element) => !(element.value.type === "value" && element.value.unit === "number"));
                const newMultiplicationNode = Object.assign(Object.assign({}, value.value), { values: nonFactorNodes });
                return Object.assign(Object.assign({}, value), { factor: (value.operation === "+" ? 1 : -1) * factor, value: newMultiplicationNode, text: (0, stringifyNode_1.stringifyNode)(newMultiplicationNode), operation: "+" });
            }
            return Object.assign(Object.assign({}, value), { factor: value.operation === "+" ? 1 : -1, text: (0, stringifyNode_1.stringifyNode)(value.value), operation: "+" });
        });
        const valueMap = values.reduce((valueMap, value) => {
            var _a, _b;
            return Object.assign(Object.assign({}, valueMap), { [value.text]: {
                    count: ((_b = (_a = valueMap[value.text]) === null || _a === void 0 ? void 0 : _a.count) !== null && _b !== void 0 ? _b : 0) + value.factor,
                    content: value.value,
                } });
        }, {});
        const valueObjects = Object.values(valueMap)
            .filter(({ count }) => count)
            .map(({ count, content }) => {
            return {
                operation: count > 0 ? "+" : "-",
                value: Math.abs(count) === 1
                    ? content
                    : {
                        type: "multiplication",
                        values: [
                            {
                                operation: "*",
                                value: {
                                    type: "value",
                                    unit: "number",
                                    value: Math.abs(count),
                                },
                            },
                            { operation: "*", value: content },
                        ],
                    },
            };
        });
        return Object.assign(Object.assign({}, node), { values: valueObjects });
    });
};
exports.combineDuplicateNodesInAddition = combineDuplicateNodesInAddition;


/***/ }),

/***/ 130:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.evaluateBasicAddition = void 0;
const addValueNodesInAddition_1 = __nccwpck_require__(154);
const removeUnnecessaryAddition_1 = __nccwpck_require__(14);
const removeAdditionIdentity_1 = __nccwpck_require__(549);
exports.evaluateBasicAddition = [
    addValueNodesInAddition_1.addValueNodesInAddition,
    removeAdditionIdentity_1.removeAdditionIdentity,
    removeUnnecessaryAddition_1.removeUnneccessaryAddition,
];


/***/ }),

/***/ 870:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.integrateNestedAddition = void 0;
const reverseVisitor_1 = __nccwpck_require__(101);
const integrateNestedAddition = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        if (node.type !== "addition") {
            return node;
        }
        const nestedAdditionValues = node.values.flatMap((value) => value.value.type === "addition"
            ? value.value.values.map((nestedValue) => ({
                operation: value.operation === nestedValue.operation ? "+" : "-",
                value: nestedValue.value,
            }))
            : []);
        const newValues = [
            ...node.values.filter((value) => value.value.type !== "addition"),
            ...nestedAdditionValues,
        ];
        return Object.assign(Object.assign({}, node), { values: newValues });
    });
};
exports.integrateNestedAddition = integrateNestedAddition;


/***/ }),

/***/ 549:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.removeAdditionIdentity = void 0;
const visitor_1 = __nccwpck_require__(9);
const removeAdditionIdentity = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "addition") {
            return node;
        }
        return Object.assign(Object.assign({}, node), { values: node.values.filter((valueNode) => (valueNode.value.type !== "value" &&
                valueNode.value.type !== "var") ||
                valueNode.value.value !== 0) });
    });
};
exports.removeAdditionIdentity = removeAdditionIdentity;


/***/ }),

/***/ 698:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.tryToKeepOnePositiveNodeInEveryAddition = void 0;
const visitor_1 = __nccwpck_require__(9);
/**
 * The shortest representation for addition nodes can be achieved, by having at least one add operation and reducing the number of signed values
 *
 * 1px + -1 => 1px - 1
 * 0 - 1in - 1px => -1in - 1px
 */
const tryToKeepOnePositiveNodeInEveryAddition = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "addition") {
            return node;
        }
        const valueElements = node.values.flatMap((value) => value.value.type === "value" ? [Object.assign(Object.assign({}, value), { value: value.value })] : []);
        const otherElements = node.values.filter((value) => value.value.type !== "value");
        const positiveValueElements = valueElements.map((element) => (Object.assign(Object.assign({}, element), { operation: element.operation === (element.value.value >= 0 ? "+" : "-")
                ? "+"
                : "-", value: Object.assign(Object.assign({}, element.value), { value: Math.abs(element.value.value) }) })));
        const alreadyHasPositiveOperation = otherElements.some((element) => element.operation === "+") ||
            positiveValueElements.some((element) => element.operation === "+");
        const newValueElements = alreadyHasPositiveOperation
            ? [...positiveValueElements, ...otherElements]
            : positiveValueElements.length > 0
                ? [
                    {
                        operation: "+",
                        value: Object.assign(Object.assign({}, positiveValueElements[0].value), { value: -1 * positiveValueElements[0].value.value }),
                    },
                    ...positiveValueElements.slice(1),
                    ...otherElements,
                ]
                : [...positiveValueElements, ...otherElements];
        return Object.assign(Object.assign({}, node), { values: newValueElements });
    });
};
exports.tryToKeepOnePositiveNodeInEveryAddition = tryToKeepOnePositiveNodeInEveryAddition;


/***/ }),

/***/ 446:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.checkMathUnitCompatibility = void 0;
const cssUnitFunctions_1 = __nccwpck_require__(35);
const reverseVisitor_1 = __nccwpck_require__(101);
const throwError = (node, message) => {
    throw new Error(`${message} at node ${JSON.stringify(node)}`);
};
const checkMathUnitCompatibility = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        switch (node.type) {
            case "var":
                return Object.assign(Object.assign({}, node), { possibleUnits: [...cssUnitFunctions_1.unitTypes] });
            case "addition": {
                const values = node.values.map((value) => value.value);
                const elements = values.map((value) => value.type === "value"
                    ? value
                    : value.possibleUnits ||
                        throwError(value, "No possible units available"));
                const possibleUnits = (0, cssUnitFunctions_1.checkAdditionCompatibility)(...elements);
                if (possibleUnits.length === 0) {
                    throwError(node, "Invalid unit");
                }
                return Object.assign(Object.assign({}, node), { possibleUnits });
            }
            case "multiplication": {
                const values = node.values.map((value) => value.value);
                const elements = values.map((value) => value.type === "value"
                    ? value
                    : value.possibleUnits ||
                        throwError(value, "No possible units available"));
                const possibleUnits = (0, cssUnitFunctions_1.checkMultiplicationCompatibility)(...elements);
                if (possibleUnits.length === 0) {
                    throwError(node, "Invalid unit");
                }
                const divisors = node.values
                    .filter((value) => value.operation === "/")
                    .map((value) => value.value);
                const divisorElements = divisors.map((value) => value.type === "value"
                    ? value
                    : value.possibleUnits ||
                        throwError(value, "No possible units available"));
                divisorElements.forEach((element, index) => (0, cssUnitFunctions_1.checkValidDivider)(element) ||
                    throwError(divisors[index], "A divisor has to be a nonzero number"));
                return Object.assign(Object.assign({}, node), { possibleUnits });
            }
            case "min":
            case "max": {
                const elements = node.values.map((value) => value.type === "value"
                    ? { unit: value.unit, value: value.value }
                    : value.possibleUnits ||
                        throwError(value, "No possible units available"));
                const possibleUnits = (0, cssUnitFunctions_1.checkMinMaxCompatibility)(...elements);
                if (possibleUnits.length === 0) {
                    throwError(node, "Invalid unit");
                }
                return Object.assign(Object.assign({}, node), { possibleUnits });
            }
            case "clamp":
                throwError(node, "Clamp nodes should be removed before unit check");
            case "parenthesis":
            case "calc":
                return Object.assign(Object.assign({}, node), { possibleUnits: node.value.possibleUnits });
            case "value":
                return Object.assign(Object.assign({}, node), { possibleUnits: (0, cssUnitFunctions_1.getCompatibleUnits)(node) });
            default:
                const x = node;
                return node;
        }
        // if(node.type === "addition") {
        //     const possibleUnits =
        //     return {
        //         ...node,
        //     }
        // }
        // const calculatedNodes = node.values.map()
    });
};
exports.checkMathUnitCompatibility = checkMathUnitCompatibility;


/***/ }),

/***/ 718:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.convertAbsoluteUnitsToCanonicalUnits = void 0;
const cssUnitFunctions_1 = __nccwpck_require__(35);
const visitor_1 = __nccwpck_require__(9);
const convertAbsoluteUnitsToCanonicalUnits = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "value") {
            return node;
        }
        const canonicalUnit = (0, cssUnitFunctions_1.convertToCanonicalUnit)(node);
        return Object.assign(Object.assign({}, node), canonicalUnit);
    });
};
exports.convertAbsoluteUnitsToCanonicalUnits = convertAbsoluteUnitsToCanonicalUnits;


/***/ }),

/***/ 654:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.detectCalcPrefixes = void 0;
const visitor_1 = __nccwpck_require__(9);
const detectCalcPrefixes = (node, storage) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        var _a, _b, _c, _d;
        if (node.type !== "calc") {
            return node;
        }
        if ((_a = storage.knownCalcPrefixes) === null || _a === void 0 ? void 0 : _a.includes((_b = node.prefix) !== null && _b !== void 0 ? _b : "calc")) {
            return node;
        }
        storage.knownCalcPrefixes = [
            ...((_c = storage.knownCalcPrefixes) !== null && _c !== void 0 ? _c : []),
            (_d = node.prefix) !== null && _d !== void 0 ? _d : "calc",
        ];
        return node;
    });
};
exports.detectCalcPrefixes = detectCalcPrefixes;


/***/ }),

/***/ 991:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.addRangeInfoToMinMaxStatements = void 0;
const cssUnitFunctions_1 = __nccwpck_require__(35);
const reverseVisitor_1 = __nccwpck_require__(101);
const mapByUnit = (values) => {
    return values.reduce((acc, { value, unit }) => {
        if (!acc[unit]) {
            acc[unit] = [];
        }
        acc[unit].push(value);
        return acc;
    }, {});
};
/**
 * If there is max statement inside a min statement, try to optimize that
 *
 * Only works if a min or max statement contains only values and opposing statements
 */
const addRangeInfoToMinMaxStatements = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        switch (node.type) {
            case "value":
                return Object.assign(Object.assign({}, node), { rangeInfo: [
                        {
                            unit: node.unit,
                            min: node.value,
                            max: node.value,
                        },
                    ] });
            case "min":
            case "max": {
                if (node.values.find((child) => child.type !== "var" && child.rangeInfo === undefined) ||
                    !node.values.find((child) => child.type !== "var") ||
                    node.values.find((child) => child.type === node.type)) {
                    return node;
                }
                const rangeInfoNodes = node.values.flatMap((value) => value.type === "value" ||
                    value.type === (node.type === "max" ? "min" : "max")
                    ? [value]
                    : []);
                const varNodes = node.values.flatMap((value) => value.type === "var" ? [value] : []);
                const hasVarNodes = !!varNodes.length;
                const rangeInfos = rangeInfoNodes.flatMap((value) => value.rangeInfo);
                const varRangeInfos = hasVarNodes
                    ? rangeInfos.map((rangeInfo) => (Object.assign(Object.assign({}, rangeInfo), { min: -Infinity, max: Infinity })))
                    : [];
                const reducedRangeInfos = rangeInfos.reduce((newRangeInfos, rangeInfo) => {
                    const sameUnitRange = newRangeInfos.find((oldRangeInfo) => oldRangeInfo.unit === rangeInfo.unit);
                    if (sameUnitRange) {
                        const min = (0, cssUnitFunctions_1.compareValues)({ unit: rangeInfo.unit, value: rangeInfo.min }, { unit: sameUnitRange.unit, value: sameUnitRange.min }) === (node.type === "max" ? 1 : -1)
                            ? rangeInfo.min
                            : sameUnitRange.min;
                        const max = (0, cssUnitFunctions_1.compareValues)({ unit: rangeInfo.unit, value: rangeInfo.max }, { unit: sameUnitRange.unit, value: sameUnitRange.max }) === (node.type === "max" ? 1 : -1)
                            ? rangeInfo.max
                            : sameUnitRange.max;
                        return [
                            ...newRangeInfos.filter((range) => range.unit !== rangeInfo.unit),
                            { unit: rangeInfo.unit, min, max },
                        ];
                    }
                    return [...newRangeInfos, rangeInfo];
                }, varRangeInfos);
                const canBeResolved = reducedRangeInfos.every((rangeInfo) => rangeInfo.min === rangeInfo.max);
                if (canBeResolved) {
                    if (reducedRangeInfos.length === 1) {
                        return Object.assign(Object.assign({}, node), { type: "value", unit: reducedRangeInfos[0].unit, value: reducedRangeInfos[0].min, rangeInfo: reducedRangeInfos });
                    }
                    return Object.assign(Object.assign({}, node), { values: reducedRangeInfos.map((rangeInfo) => ({
                            type: "value",
                            unit: rangeInfo.unit,
                            value: rangeInfo.min,
                        })), rangeInfo: reducedRangeInfos });
                }
                return Object.assign(Object.assign({}, node), { rangeInfo: reducedRangeInfos });
                // const varNodes = node.values.flatMap((value) =>
                //   value.type === "var" ? [value] : []
                // );
            }
            default:
                return node;
        }
    });
};
exports.addRangeInfoToMinMaxStatements = addRangeInfoToMinMaxStatements;


/***/ }),

/***/ 627:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.clampToMinAndMax = void 0;
const visitor_1 = __nccwpck_require__(9);
const clampToMinAndMax = (node) => {
    return (0, visitor_1.visitor)(node, (node) => node.type === "clamp", (node) => {
        if (node.type !== "clamp") {
            throw new Error("This should always be a clamp node");
        }
        return Object.assign(Object.assign({}, node), { type: "max", values: [node.min, { type: "min", values: [node.value, node.max] }] });
    });
};
exports.clampToMinAndMax = clampToMinAndMax;


/***/ }),

/***/ 362:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.integrateNestedMinMaxNodes = void 0;
const visitor_1 = __nccwpck_require__(9);
const integrateNestedMinMaxNodes = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "min" && node.type !== "max") {
            return node;
        }
        return Object.assign(Object.assign({}, node), { values: [
                ...node.values.filter((valueNode) => valueNode.type !== node.type),
                ...node.values.flatMap((valueNode) => valueNode.type === node.type ? valueNode.values : []),
            ] });
    });
};
exports.integrateNestedMinMaxNodes = integrateNestedMinMaxNodes;


/***/ }),

/***/ 524:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.minAndMaxToClamp = void 0;
const visitor_1 = __nccwpck_require__(9);
const minAndMaxToClamp = (node) => {
    return (0, visitor_1.visitor)(node, (node) => node.type === "max", (node) => {
        if (node.type !== "max") {
            throw new Error("This should always be a clamp node");
        }
        if (node.values.length === 2 &&
            node.values[0].type === "min" &&
            node.values[0].values.length === 2) {
            return Object.assign(Object.assign({}, node), { type: "clamp", min: node.values[1], value: node.values[0].values[0], max: node.values[0].values[1] });
        }
        if (node.values.length === 2 &&
            node.values[1].type === "min" &&
            node.values[1].values.length === 2) {
            return Object.assign(Object.assign({}, node), { type: "clamp", min: node.values[0], value: node.values[1].values[0], max: node.values[1].values[1] });
        }
        return node;
    });
};
exports.minAndMaxToClamp = minAndMaxToClamp;


/***/ }),

/***/ 171:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.removeObviousMinMaxValues = void 0;
const visitor_1 = __nccwpck_require__(9);
const mapByUnit = (values) => {
    return values.reduce((acc, { value, unit }) => {
        if (!acc[unit]) {
            acc[unit] = [];
        }
        acc[unit].push(value);
        return acc;
    }, {});
};
/**
 * If there are multiple values with the same unit in a min/max node, just use the min/max of the values.
 */
const removeObviousMinMaxValues = (node) => {
    return (0, visitor_1.visitor)(node, (node) => node.type === "min" || node.type === "max", (node) => {
        if (node.type !== "min" && node.type !== "max") {
            throw new Error("This should always be a min node");
        }
        const valueNodes = node.values.flatMap((value) => value.type === "value" ? [value] : []);
        const otherNodes = node.values.flatMap((value) => value.type !== "value" ? [value] : []);
        const valuesByUnit = mapByUnit(valueNodes);
        const bestValues = Object.entries(valuesByUnit).map(([unit, values]) => ({
            type: "value",
            unit: unit,
            value: values.reduce((acc, value) => Math[node.type](acc, value), values[0]),
        }));
        const newValues = [...bestValues, ...otherNodes];
        if (newValues.length === 1) {
            return newValues[0];
        }
        return Object.assign(Object.assign({}, node), { values: newValues });
    });
};
exports.removeObviousMinMaxValues = removeObviousMinMaxValues;


/***/ }),

/***/ 109:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.evaluateBasicMultiplication = void 0;
const stringifyNode_1 = __nccwpck_require__(955);
const visitor_1 = __nccwpck_require__(9);
/**
 * Remove units in a multiplication that cancel each other out
 */
const removeCancelledOutUnits = (node) => {
    const valueElements = node.values.flatMap((value) => value.value.type === "value" ? [Object.assign(Object.assign({}, value), { value: value.value })] : []);
    const otherElements = node.values.filter((value) => value.value.type !== "value");
    const unitCounter = valueElements.reduce((acc, value) => {
        var _a, _b, _c, _d;
        return (Object.assign(Object.assign({}, acc), { [value.value.unit]: {
                division: [
                    ...((_b = (_a = acc[value.value.unit]) === null || _a === void 0 ? void 0 : _a.division) !== null && _b !== void 0 ? _b : []),
                    ...(value.operation === "/" ? [value.value] : []),
                ],
                multiplication: [
                    ...((_d = (_c = acc[value.value.unit]) === null || _c === void 0 ? void 0 : _c.multiplication) !== null && _d !== void 0 ? _d : []),
                    ...(value.operation === "*" ? [value.value] : []),
                ],
            } }));
    }, {});
    const newValueElements = Object.entries(unitCounter).flatMap(([unit, { division, multiplication }]) => {
        const cancelledOut = Math.min(division.length, multiplication.length);
        const elementsWithUnitsRemoved = [
            ...division.map((element, index) => ({
                operation: "/",
                value: index < cancelledOut ? Object.assign(Object.assign({}, element), { unit: "number" }) : element,
            })),
            ...multiplication.map((element, index) => ({
                operation: "*",
                value: index < cancelledOut ? Object.assign(Object.assign({}, element), { unit: "number" }) : element,
            })),
        ];
        return elementsWithUnitsRemoved;
    });
    return Object.assign(Object.assign({}, node), { values: [...otherElements, ...newValueElements] });
};
/**
 * Remove units in a multiplication that cancel each other out
 */
const removeCancelledOutElements = (node) => {
    const elements = node.values.map((element) => ({
        text: (0, stringifyNode_1.stringifyNode)(element.value),
        operation: element.operation,
        node: element.value,
    }));
    const sortedElements = elements.reduce((acc, value) => {
        var _a, _b, _c, _d;
        return (Object.assign(Object.assign({}, acc), { [value.text]: {
                division: [
                    ...((_b = (_a = acc[value.text]) === null || _a === void 0 ? void 0 : _a.division) !== null && _b !== void 0 ? _b : []),
                    ...(value.operation === "/" ? [value.node] : []),
                ],
                multiplication: [
                    ...((_d = (_c = acc[value.text]) === null || _c === void 0 ? void 0 : _c.multiplication) !== null && _d !== void 0 ? _d : []),
                    ...(value.operation === "*" ? [value.node] : []),
                ],
            } }));
    }, {});
    const newValueElements = Object.entries(sortedElements).flatMap(([unit, { division, multiplication }]) => {
        const cancelledOut = Math.min(division.length, multiplication.length);
        const elementsWithUnitsRemoved = [
            ...division
                .slice(cancelledOut)
                .map((element) => ({ operation: "/", value: element })),
            ...multiplication
                .slice(cancelledOut)
                .map((element) => ({ operation: "*", value: element })),
        ];
        return elementsWithUnitsRemoved;
    });
    return Object.assign(Object.assign({}, node), { values: newValueElements });
};
const moveAllFactorIntoASingleNumber = (node) => {
    const valueElements = node.values.flatMap((value) => value.value.type === "value" ? [Object.assign(Object.assign({}, value), { value: value.value })] : []);
    const otherElements = node.values.filter((value) => value.value.type !== "value");
    const globalFactor = valueElements.reduce((factor, element) => factor *
        (element.operation === "*"
            ? element.value.value
            : 1 / element.value.value), 1);
    const normalizedValueElements = valueElements
        .filter((element) => element.value.unit !== "number")
        .map((element) => (Object.assign(Object.assign({}, element), { value: Object.assign(Object.assign({}, element.value), { value: 1 }) })));
    const newValueElements = [
        {
            operation: "*",
            value: { type: "value", value: globalFactor, unit: "number" },
        },
        ...normalizedValueElements,
        ...otherElements,
    ];
    return Object.assign(Object.assign({}, node), { values: newValueElements });
};
const ensureNoDivisionByZero = (node) => {
    const zeroDivisions = node.values.forEach((value) => {
        if (value.value.type === "value" &&
            value.operation === "/" &&
            value.value.value === 0) {
            throw new Error(`Division by zero in ${(0, stringifyNode_1.stringifyNode)(node)}`);
        }
    });
    return node;
};
const integrateUnitlessNodeIntoUnitNode = (node) => {
    const valueElements = node.values.flatMap((value) => value.value.type === "value" ? [Object.assign(Object.assign({}, value), { value: value.value })] : []);
    const otherElements = node.values.filter((value) => value.value.type !== "value");
    const unitlessNodes = valueElements.filter((element) => element.value.unit === "number");
    const unitlessFactor = unitlessNodes.reduce((factor, element) => factor *
        (element.operation === "*"
            ? element.value.value
            : 1 / element.value.value), 1);
    const newNodeBase = valueElements.find((element) => element.value.unit !== "number" && element.operation === "*") ||
        {
            operation: "*",
            value: { type: "value", value: 1, unit: "number" },
        };
    const factor = newNodeBase.value.value *
        (newNodeBase.operation === "*" ? unitlessFactor : 1 / unitlessFactor);
    const newNode = Object.assign(Object.assign({}, newNodeBase), { value: Object.assign(Object.assign({}, newNodeBase.value), { value: factor }) });
    const remainingElements = [
        ...valueElements.filter((element) => element !== newNodeBase && element.value.unit !== "number"),
        ...otherElements,
    ];
    const newValueElements = [newNode, ...remainingElements];
    return Object.assign(Object.assign({}, node), { values: newValueElements });
};
const removeMultiplicationIdentity = (node) => {
    const filteredValues = node.values.filter((value) => !(value.value.type === "value" &&
        value.value.unit === "number" &&
        value.value.value === 1));
    if (filteredValues.length === 0) {
        return Object.assign(Object.assign({}, node), { values: [
                { operation: "*", value: { type: "value", value: 1, unit: "number" } },
            ] });
    }
    return Object.assign(Object.assign({}, node), { values: filteredValues });
};
const removeUnneccessaryMultiplication = (node) => {
    if (node.values.find((element) => element.value.type === "value" && element.value.value === 0)) {
        return Object.assign(Object.assign({}, node), { type: "value", unit: "number", value: 0 });
    }
    if (node.values.length === 1 && node.values[0].operation === "*") {
        return node.values[0].value;
    }
    if (node.values.length === 0) {
        return Object.assign(Object.assign({}, node), { type: "value", unit: "number", value: 1 });
    }
    return node;
};
/**
 * All multiplication optimizations, that do not look into children other then value nodes
 */
const evaluateBasicMultiplication = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "multiplication") {
            return node;
        }
        const stage1 = removeCancelledOutUnits(node);
        const stage11 = removeCancelledOutElements(stage1);
        const stage12 = ensureNoDivisionByZero(stage11);
        const stage2 = moveAllFactorIntoASingleNumber(stage12);
        const stage3 = integrateUnitlessNodeIntoUnitNode(stage2);
        const stage4 = removeMultiplicationIdentity(stage3);
        const stage5 = removeUnneccessaryMultiplication(stage4);
        return stage5;
    });
};
exports.evaluateBasicMultiplication = evaluateBasicMultiplication;


/***/ }),

/***/ 616:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.expandMultiplications = void 0;
const reverseVisitor_1 = __nccwpck_require__(101);
/**
 * Convert multiplications to the expanded form
 *
 * (a+b) * (c+d) => a*c + a*d + b*c + b*d
 * (a+b) * (x+y) / (c+d) / f = (ax+ay+bx+by) / (cf+df)
 * (ax+ay+bx+by) / (cf+df) =>
 * ax/(cf+df) =>
 */
const expandMultiplications = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        if (node.type !== "multiplication") {
            return node;
        }
        const multiplicationNodes = node.values
            .filter((value) => value.operation === "*")
            .map((value) => value.value);
        const divisionNodes = node.values
            .filter((value) => value.operation === "/")
            .map((value) => value.value);
        const multiplicationComponents = multiplicationNodes
            .map((node) => node.type === "parenthesis" || node.type === "calc" ? node.value : node)
            .map((node) => node.type === "addition"
            ? node.values
            : [{ operation: "+", value: node }]);
        // const divisionComponents = divisionNodes
        //   .map((node) => ((node.type === "parenthesis" || node.type === "calc") ? node.value : node))
        //   .map((node) =>
        //     node.type === "addition"
        //       ? node.values
        //       : [{ operation: "+" as const, value: node as Node }]
        //   );
        const multNodes = multiplicationComponents.reduce((acc, components) => {
            return acc.flatMap((oldSum) => components.map((component) => ({
                operation: component.operation === oldSum.operation
                    ? "+"
                    : "-",
                values: [...oldSum.values, component.value],
            })));
        }, [
            {
                operation: "+",
                values: [],
            },
        ]);
        // const divNodes = divisionComponents.reduce(
        //   (acc, components) => {
        //     return acc.flatMap((oldSum) =>
        //       components.map((component) => ({
        //         operation:
        //           component.operation === oldSum.operation
        //             ? ("+" as const)
        //             : ("-" as const),
        //         values: [...oldSum.values, component.value],
        //       }))
        //     );
        //   },
        //   [
        //     {
        //       operation: "+",
        //       values: [],
        //     },
        //   ] as { operation: "+" | "-"; values: Node[] }[]
        // );
        // const multiplicationSum: AdditionNode | undefined =
        //   multNodes.length === 0
        //     ? undefined
        //     : {
        //         type: "addition",
        //         values: multNodes.map((multNode) => ({
        //           operation: multNode.operation,
        //           value: {
        //             type: "multiplication",
        //             values: [
        //               ...multNode.values.map(
        //                 (value) => ({ operation: "*", value } as const)
        //               ),
        //             ],
        //           },
        //         })),
        //       };
        // const divisionSum: AdditionNode | undefined =
        //   divNodes.length === 0
        //     ? undefined
        //     : {
        //         type: "addition",
        //         values: divNodes.map((divNode) => ({
        //           operation: divNode.operation,
        //           value: {
        //             type: "multiplication",
        //             values: [
        //               ...divNode.values.map(
        //                 (value) => ({ operation: "*", value } as const)
        //               ),
        //             ],
        //           },
        //         })),
        //       };
        // const resultNode: Node | undefined = divisionSum
        //   ? {
        //       type: "multiplication",
        //       values: [
        //         ...(multiplicationSum
        //           ? [{ operation: "*" as const, value: multiplicationSum }]
        //           : []),
        //         { operation: "/", value: divisionSum },
        //       ],
        //     }
        //   : multiplicationSum;
        const resultNode = multNodes.length === 0
            ? undefined
            : {
                type: "addition",
                values: multNodes.map((multNode) => ({
                    operation: multNode.operation,
                    value: {
                        type: "multiplication",
                        values: [
                            ...multNode.values.map((value) => ({ operation: "*", value })),
                            ...divisionNodes.map((node) => ({
                                operation: "/",
                                value: node,
                            })),
                        ],
                    },
                })),
            };
        if (!resultNode) {
            throw new Error(`Failed to expand node ${node}`);
        }
        return resultNode;
    });
};
exports.expandMultiplications = expandMultiplications;


/***/ }),

/***/ 289:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.integrateNestedMultiplication = void 0;
const reverseVisitor_1 = __nccwpck_require__(101);
const integrateNestedMultiplication = (node) => {
    return (0, reverseVisitor_1.reverseVisitor)(node, (node) => {
        if (node.type !== "multiplication") {
            return node;
        }
        const nestedMultiplicationValues = node.values.flatMap((value) => value.value.type === "multiplication"
            ? value.value.values.map((nestedValue) => ({
                operation: value.operation === nestedValue.operation ? "*" : "/",
                value: nestedValue.value,
            }))
            : []);
        const newValues = [
            ...node.values.filter((value) => value.value.type !== "multiplication"),
            ...nestedMultiplicationValues,
        ];
        return Object.assign(Object.assign({}, node), { values: newValues });
    });
};
exports.integrateNestedMultiplication = integrateNestedMultiplication;


/***/ }),

/***/ 473:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.sortNodes = void 0;
const stringifyNode_1 = __nccwpck_require__(955);
const visitor_1 = __nccwpck_require__(9);
const sortNodes = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type === "addition") {
            return Object.assign(Object.assign({}, node), { values: node.values.sort((a, b) => {
                    const aString = (0, stringifyNode_1.stringifyNode)(a.value);
                    const bString = (0, stringifyNode_1.stringifyNode)(b.value);
                    return aString.localeCompare(bString);
                }) });
        }
        if (node.type === "multiplication") {
            return Object.assign(Object.assign({}, node), { values: node.values.sort((a, b) => {
                    const aString = (0, stringifyNode_1.stringifyNode)(a.value);
                    const bString = (0, stringifyNode_1.stringifyNode)(b.value);
                    return aString.localeCompare(bString);
                }) });
        }
        if (node.type === "min" || node.type === "max") {
            return Object.assign(Object.assign({}, node), { values: node.values.sort((a, b) => {
                    const aString = (0, stringifyNode_1.stringifyNode)(a);
                    const bString = (0, stringifyNode_1.stringifyNode)(b);
                    return aString.localeCompare(bString);
                }) });
        }
        return node;
    });
};
exports.sortNodes = sortNodes;


/***/ }),

/***/ 642:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.stripOptionalInformation = void 0;
const visitor_1 = __nccwpck_require__(9);
const stripOptionalInformation = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        delete node.possibleUnits;
        delete node.rangeInfo;
        return node;
    });
};
exports.stripOptionalInformation = stripOptionalInformation;


/***/ }),

/***/ 164:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.stripUnnecessaryMathNode = void 0;
const visitor_1 = __nccwpck_require__(9);
const stripUnnecessaryMathNode = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "addition" && node.type !== "multiplication") {
            return node;
        }
        if (node.values.length !== 1) {
            return node;
        }
        if (node.values.length === 1 &&
            (node.values[0].operation === "*" || node.values[0].operation === "+")) {
            return node.values[0].value;
        }
        if (node.values.length === 1 &&
            (node.values[0].operation === "-" ||
                node.values[0].operation === "/") &&
            node.values[0].value.type === "value") {
            return {
                type: "value",
                unit: node.values[0].value.unit,
                value: node.values[0].operation === "-"
                    ? node.values[0].value.value * -1
                    : 1 / node.values[0].value.value,
            };
        }
        return node;
    });
};
exports.stripUnnecessaryMathNode = stripUnnecessaryMathNode;


/***/ }),

/***/ 62:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.stripUnnecessaryParenthesis = void 0;
const visitor_1 = __nccwpck_require__(9);
const stripUnnecessaryParenthesis = (node) => {
    return (0, visitor_1.visitor)(node, () => true, (node) => {
        if (node.type !== "parenthesis" && node.type !== "calc") {
            return node;
        }
        return node.value;
    });
};
exports.stripUnnecessaryParenthesis = stripUnnecessaryParenthesis;


/***/ }),

/***/ 91:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.parseCalc = void 0;
const optimizeAst_1 = __nccwpck_require__(512);
const addCalcOnRootLevelIfRequired_1 = __nccwpck_require__(666);
const combineDuplicateNodesInAddition_1 = __nccwpck_require__(735);
const evaluateBasicAddition_1 = __nccwpck_require__(130);
const integrateNestedAddition_1 = __nccwpck_require__(870);
const removeAdditionIdentity_1 = __nccwpck_require__(549);
const tryToKeepOnePositiveNodeInEveryAddition_1 = __nccwpck_require__(698);
const addNecessaryParenthesis_1 = __nccwpck_require__(762);
const checkMathUnitCompatibility_1 = __nccwpck_require__(446);
const convertAbsoluteUnitsToCanonicalUnits_1 = __nccwpck_require__(718);
const detectCalcPrefixes_1 = __nccwpck_require__(654);
const addRangeInfoToMinMaxNodes_1 = __nccwpck_require__(991);
const clampToMinAndMax_1 = __nccwpck_require__(627);
const integrateNestedMinMaxNodes_1 = __nccwpck_require__(362);
const minAndMaxToClamp_1 = __nccwpck_require__(524);
const removeObviousMinMaxValues_1 = __nccwpck_require__(171);
const evaluateBasicMultiplication_1 = __nccwpck_require__(109);
const expandMultiplications_1 = __nccwpck_require__(616);
const integrateNestedMultiplication_1 = __nccwpck_require__(289);
const sortNodes_1 = __nccwpck_require__(473);
const stripOptionalInformation_1 = __nccwpck_require__(642);
const stripUnnecessaryMathNode_1 = __nccwpck_require__(164);
const stripUnnecessaryParenthesis_1 = __nccwpck_require__(62);
const stringifyNode_1 = __nccwpck_require__(955);
const optimizations = [
    [detectCalcPrefixes_1.detectCalcPrefixes, clampToMinAndMax_1.clampToMinAndMax, convertAbsoluteUnitsToCanonicalUnits_1.convertAbsoluteUnitsToCanonicalUnits],
    // This stage does most of the optimizations, but may leave the ast weirdly formatted
    [
        sortNodes_1.sortNodes,
        stripUnnecessaryParenthesis_1.stripUnnecessaryParenthesis,
        stripUnnecessaryMathNode_1.stripUnnecessaryMathNode,
        sortNodes_1.sortNodes,
        integrateNestedMinMaxNodes_1.integrateNestedMinMaxNodes,
        expandMultiplications_1.expandMultiplications,
        integrateNestedAddition_1.integrateNestedAddition,
        integrateNestedMultiplication_1.integrateNestedMultiplication,
        evaluateBasicAddition_1.evaluateBasicAddition,
        evaluateBasicMultiplication_1.evaluateBasicMultiplication,
        sortNodes_1.sortNodes,
        removeAdditionIdentity_1.removeAdditionIdentity,
        sortNodes_1.sortNodes,
        removeObviousMinMaxValues_1.removeObviousMinMaxValues,
        stripUnnecessaryMathNode_1.stripUnnecessaryMathNode,
        addRangeInfoToMinMaxNodes_1.addRangeInfoToMinMaxStatements,
        combineDuplicateNodesInAddition_1.combineDuplicateNodesInAddition,
        stripUnnecessaryMathNode_1.stripUnnecessaryMathNode,
        sortNodes_1.sortNodes,
    ],
    // Do a final round of value math
    [evaluateBasicMultiplication_1.evaluateBasicMultiplication, evaluateBasicAddition_1.evaluateBasicAddition],
    // Clean and reduce tree
    [
        sortNodes_1.sortNodes,
        removeAdditionIdentity_1.removeAdditionIdentity,
        stripUnnecessaryMathNode_1.stripUnnecessaryMathNode,
        stripUnnecessaryParenthesis_1.stripUnnecessaryParenthesis,
    ],
    // Check for math unit compatibility
    checkMathUnitCompatibility_1.checkMathUnitCompatibility,
    [
        stripUnnecessaryMathNode_1.stripUnnecessaryMathNode,
        addNecessaryParenthesis_1.addNecessaryParenthesis,
        tryToKeepOnePositiveNodeInEveryAddition_1.tryToKeepOnePositiveNodeInEveryAddition,
        sortNodes_1.sortNodes,
        minAndMaxToClamp_1.minAndMaxToClamp,
        addCalcOnRootLevelIfRequired_1.addCalcOnRootLevelIfRequired,
        stripOptionalInformation_1.stripOptionalInformation,
    ],
];
const parseCalc = (input, parserFunction) => {
    const ast = parserFunction(input);
    const optimizedAst = (0, optimizeAst_1.optimizeAst)(ast, optimizations);
    return (0, stringifyNode_1.stringifyNode)(optimizedAst);
};
exports.parseCalc = parseCalc;


/***/ }),

/***/ 101:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.reverseVisitor = void 0;
const reverseVisitor = (node, visit) => {
    const thisVisitor = (node) => (0, exports.reverseVisitor)(node, visit);
    const getNode = (newNode) => {
        switch (newNode.type) {
            case "value":
                return newNode;
            case "min":
            case "max":
                return Object.assign(Object.assign({}, newNode), { values: newNode.values.map((value) => thisVisitor(value)) });
            case "clamp":
                return Object.assign(Object.assign({}, newNode), { min: thisVisitor(newNode.min), value: thisVisitor(newNode.value), max: thisVisitor(newNode.max) });
            case "parenthesis":
                return Object.assign(Object.assign({}, newNode), { value: thisVisitor(newNode.value) });
            case "addition":
                return Object.assign(Object.assign({}, newNode), { values: newNode.values.map((node) => (Object.assign(Object.assign({}, node), { value: thisVisitor(node.value) }))) });
            case "multiplication":
                return Object.assign(Object.assign({}, newNode), { values: newNode.values.map((node) => (Object.assign(Object.assign({}, node), { value: thisVisitor(node.value) }))) });
            case "calc":
                return Object.assign(Object.assign({}, newNode), { value: thisVisitor(newNode.value) });
            case "var":
                return Object.assign(Object.assign({}, newNode), { values: Object.fromEntries(Object.entries(newNode.values).map(([key, node]) => [
                        key,
                        thisVisitor(node),
                    ])) });
            default:
                const x = newNode;
                throw new Error("Node has unknown type");
        }
    };
    const nodeToVisit = getNode(node);
    const newNode = visit(nodeToVisit);
    return newNode;
};
exports.reverseVisitor = reverseVisitor;


/***/ }),

/***/ 955:
/***/ ((__unused_webpack_module, exports, __nccwpck_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.debugNode = exports.stringifyNode = void 0;
const cssUnitFunctions_1 = __nccwpck_require__(35);
let normalConsole = __nccwpck_require__(206);
const stringifyNode = (node) => {
    switch (node.type) {
        case "value":
            return stringifyValue(node);
        case "min":
        case "max":
            return stringifyMinMax(node);
        case "clamp":
            return stringifyClamp(node);
        case "parenthesis":
            return stringifyParenthesis(node);
        case "addition":
            return stringifyAddition(node);
        case "multiplication":
            return stringifyMultiplication(node);
        case "calc":
            return stringifyCalc(node);
        case "var":
            return stringifyVar(node);
        default:
            const x = node;
            return "";
    }
};
exports.stringifyNode = stringifyNode;
const debugNode = (node, indent = 0) => {
    var _a;
    switch (node.type) {
        case "value":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}${stringifyValue(node)}`);
            return;
        case "min":
        case "max":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}${node.type}`);
            node.values.forEach((value) => (0, exports.debugNode)(value, indent + 2));
            return;
        case "clamp":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}clamp`);
            (0, exports.debugNode)(node.min, indent + 2);
            (0, exports.debugNode)(node.value, indent + 2);
            (0, exports.debugNode)(node.max, indent + 2);
            return;
        case "parenthesis":
            // normalConsole.log(`${new Array(indent).fill(" ").join("")}(`);
            (0, exports.debugNode)(node.value, indent);
            // normalConsole.log(`${new Array(indent).fill(" ").join("")})`);
            return;
        case "addition":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}addition`);
            node.values.forEach((value) => {
                normalConsole.log(`${new Array(indent).fill(" ").join("")}${value.operation}`);
                (0, exports.debugNode)(value.value, indent + 2);
            });
            return;
        case "multiplication":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}multiplication`);
            node.values.forEach((value) => {
                normalConsole.log(`${new Array(indent).fill(" ").join("")}${value.operation}`);
                (0, exports.debugNode)(value.value, indent + 2);
            });
            return;
        case "calc":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}${(_a = node.prefix) !== null && _a !== void 0 ? _a : "calc"}(`);
            (0, exports.debugNode)(node.value, indent + 2);
            normalConsole.log(`${new Array(indent).fill(" ").join("")})`);
            return;
        case "var":
            normalConsole.log(`${new Array(indent).fill(" ").join("")}${stringifyVar(node)}`);
            return;
        default:
            const x = node;
            normalConsole.log("error");
    }
};
exports.debugNode = debugNode;
//Reliably round to a given number of decimal places
const round = (value, maxPrecision) => +(+value.toFixed(maxPrecision + 1)).toFixed(maxPrecision);
const stringifyValue = (node, precision = 5) => {
    if (node.value == 0) {
        return "0";
    }
    if (node.unit === "number" || node.unit === "integer") {
        return `${round(node.value, precision)}`;
    }
    if (cssUnitFunctions_1.cssUnits.includes(node.unit)) {
        return `${round(node.value, precision)}${node.unit}`;
    }
    throw new Error(`Can not to convert value node with value: ${round(node.value, precision)} and unit: ${node.unit} to string`);
};
const stringifyVar = (node) => {
    const replacementStrings = Object.entries(node.values).map(([key, node]) => [key, (0, exports.stringifyNode)(node)]);
    const safeKeys = new Array(replacementStrings.length).fill(0).map(() => new Array(20)
        .fill(0)
        .map(() => Math.random().toString(36)[2])
        .join(""));
    const safeTemplate = Object.keys(node.values).reduce((template, string, index) => template.replaceAll(string, safeKeys[index]), node.value);
    const result = replacementStrings
        .map(([key, text], index) => [safeKeys[index], text])
        .reduce((template, [key, text]) => template.replaceAll(key, text), safeTemplate);
    return result;
};
const stringifyMinMax = (node) => {
    return `${node.type}(${node.values.map(exports.stringifyNode).join(",")})`;
};
const stringifyClamp = (node) => {
    return `clamp(${(0, exports.stringifyNode)(node.min)},${(0, exports.stringifyNode)(node.value)},${(0, exports.stringifyNode)(node.max)})`;
};
const stringifyParenthesis = (node) => {
    return `(${(0, exports.stringifyNode)(node.value)})`;
};
const stringifyAddition = (node) => {
    if (node.values.length === 0) {
        throw new Error("Can not stringify empty addition node");
    }
    const positiveValues = node.values
        .filter((value) => value.operation === "+")
        .map((value) => value.value)
        .map((value) => (0, exports.stringifyNode)(value));
    const negativeValues = node.values
        .filter((value) => value.operation === "-")
        .map((value) => value.value)
        .map((value) => (0, exports.stringifyNode)(value));
    const positiveValuesOrZero = positiveValues.length ? positiveValues : ["0"];
    return [positiveValuesOrZero.join(" + "), ...negativeValues].join(" - ");
};
const stringifyMultiplication = (node) => {
    if (node.values.length === 0) {
        throw new Error("Can not stringify empty multiplication node");
    }
    const multiplicationValues = node.values
        .filter((value) => value.operation === "*")
        .map((value) => value.value)
        .map((value) => (0, exports.stringifyNode)(value));
    const divisionValues = node.values
        .filter((value) => value.operation === "/")
        .map((value) => value.value)
        .map((value) => (0, exports.stringifyNode)(value));
    const multiplicationValuesOrOne = multiplicationValues.length
        ? multiplicationValues
        : ["1"];
    return [multiplicationValuesOrOne.join("*"), ...divisionValues].join("/");
};
const stringifyCalc = (node) => {
    var _a;
    return `${(_a = node.prefix) !== null && _a !== void 0 ? _a : "calc"}(${(0, exports.stringifyNode)(node.value)})`;
};


/***/ }),

/***/ 9:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.visitor = void 0;
const visitor = (node, checkVisit, visit, options) => {
    const visitNode = checkVisit(node);
    const newNode = visitNode ? visit(node) : node;
    if (visitNode && (options === null || options === void 0 ? void 0 : options.dontVisitChildrenAgain)) {
        return newNode;
    }
    const thisVisitor = (node) => (0, exports.visitor)(node, checkVisit, visit);
    switch (newNode.type) {
        case "value":
            return newNode;
        case "min":
        case "max":
            return Object.assign(Object.assign({}, newNode), { values: newNode.values.map((value) => thisVisitor(value)) });
        case "clamp":
            return Object.assign(Object.assign({}, newNode), { min: thisVisitor(newNode.min), value: thisVisitor(newNode.value), max: thisVisitor(newNode.max) });
        case "parenthesis":
        case "calc":
            return Object.assign(Object.assign({}, newNode), { value: thisVisitor(newNode.value) });
        case "addition":
            return Object.assign(Object.assign({}, newNode), { values: newNode.values.map((node) => (Object.assign(Object.assign({}, node), { value: thisVisitor(node.value) }))) });
        case "multiplication":
            return Object.assign(Object.assign({}, newNode), { values: newNode.values.map((node) => (Object.assign(Object.assign({}, node), { value: thisVisitor(node.value) }))) });
        case "var":
            return Object.assign(Object.assign({}, newNode), { values: Object.fromEntries(Object.entries(newNode.values).map(([key, node]) => [
                    key,
                    thisVisitor(node),
                ])) });
        default:
            const x = newNode;
            throw new Error("Node has unknown type");
    }
};
exports.visitor = visitor;


/***/ }),

/***/ 206:
/***/ ((module) => {

module.exports = require("console");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __nccwpck_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		var threw = true;
/******/ 		try {
/******/ 			__webpack_modules__[moduleId](module, module.exports, __nccwpck_require__);
/******/ 			threw = false;
/******/ 		} finally {
/******/ 			if(threw) delete __webpack_module_cache__[moduleId];
/******/ 		}
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat */
/******/ 	
/******/ 	if (typeof __nccwpck_require__ !== 'undefined') __nccwpck_require__.ab = __dirname + "/";
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __nccwpck_require__(144);
/******/ 	module.exports = __webpack_exports__;
/******/ 	
/******/ })()
;